<?php

$langObj = new languages();

class languages {

    public $mDb;
    public $mConfig;
    public $dateTime;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    function getLanguagesByParams($aStart, $aLimit, $sort, $type, $searchName) {
        $sql = "SELECT l.id, l.name, l.code, l.date_added, l.lang_image, u.user_name AS 'addedBy' FROM `languages` l";
        $sql .= " LEFT JOIN `users` u ON u.id = l.admin_id ";
        $sql .= " WHERE l.id > 0";

        $sql .= $searchName ? ' AND l.name like "%' . $searchName . '%"' : '';

        $sql .= " ORDER BY l.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//       echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchLanguagesCount($sort, $type, $searchName) {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'result_count' FROM `languages`";
        $sql .= " WHERE `id` > 0";

        $sql .= $searchName ? ' AND `name` like "%' . $searchName . '%"' : '';

        $sql .= " ORDER BY {$sort} {$type}";

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getLanguagesCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `languages`";
        return $this->mDb->getOne($sql);
    }

    function addEditLanguage($temp) {

        //var_dump($request); die();


        if ($temp['id'] === null || $temp['id'] === '') {
            // Add


            $sql = "INSERT INTO `languages` SET ";
            foreach ($this->mDb->getCols('languages', $temp) as $k => $v) {
                $sql .= "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";

            // echo $sql; die();

            return $this->mDb->query($sql);
        } else {

            // Edit


            if ($temp['lang_image'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/languages/' . $image;
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
            $sql = "UPDATE `languages` SET ";
            foreach ($this->mDb->getCols('languages', $temp) as $k => $v) {
                $sql .= ($k == 'id') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";

            return $this->mDb->query($sql);
        }
    }

    function getimg($id) {
        $sql = "SELECT `lang_image` FROM `languages`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getOne($sql);
    }

    function getOneLanguage($id) {
        $sql = "SELECT `id`, `name`, `code`, `lang_image`, `date_added` FROM `languages`";
        $sql .= " WHERE `id` = '$id' ";
        return $this->mDb->getRow($sql);
    }

    function deleteLanguage($ids) {

        $res = false;

        $sql = "DELETE FROM `languages` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $query = "SELECT `lang_image` FROM `languages` WHERE `id` = '{$id}'";
            $result = $this->mDb->getOne($query);

            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/languages/' . $result;

            if (file_exists($old_img)) {
                @unlink($old_img);
            }

            $sql .= " || `id` = '{$id}' ";
        }

        $res = $this->mDb->query($sql);
        return $res;
    }

    function getAllLanguages() {
        $sql = "SELECT `id`, `name`, `code`, `lang_image` FROM `languages` ";
        $sql .= " ORDER BY id ASC";

        return $this->mDb->getAll($sql);
    }
}
