<?php

$offersObj = new offers();

class offers {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;
    public $productsObj;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; //  
        $this->productsObj = new Products();
    }

    public function getOffers(
            $aStart,
            $aLimit,
            $sort,
            $type,
            $searchTitle,
            $searchAffiliator_id
    ) {
        $sql = "SELECT 
                    p.* ,
                    pl.title ,
                    pl.description , 
                    pl.attachment_single , 
                    u.user_name AS 'addedBy' , 
                    u2.user_name AS 'affiliator_name' 
                FROM offers p
                LEFT JOIN offer_langs pl ON p.id = pl.offer_id AND pl.lang_code = :lang_code 
                LEFT JOIN users u ON u.id = p.admin_id
                LEFT JOIN users u2 ON u2.id = p.affiliator_id
                WHERE p.id > 0 ";
        $searchTitle ? $sql .= ' AND pl.title LIKE :searchTitle' : '';
        $searchAffiliator_id ? $sql .= ' AND p.affiliator_id LIKE :searchAffiliator_id' : '';
        $sql .= " Group by p.id  ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':lang_code', $this->lang_code, PDO::PARAM_STR);
        $searchTitle ? $stmt->bindValue(':searchTitle', '%' . $searchTitle . '%', PDO::PARAM_STR) : '';
        $searchAffiliator_id ? $stmt->bindValue(':searchAffiliator_id', '%' . $searchAffiliator_id . '%', PDO::PARAM_STR) : '';
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getSearchOffersCount(
            $sort,
            $type,
            $searchTitle,
            $searchAffiliator_id
    ) {
        $sql = "SELECT COUNT(DISTINCT  p.id) as 'result_count' 
                FROM offers p
                LEFT JOIN offer_langs pl ON p.id = pl.offer_id
                WHERE p.id > 0";
        $searchTitle ? $sql .= ' AND pl.title LIKE :searchTitle' : '';
        $searchAffiliator_id ? $sql .= ' AND p.affiliator_id LIKE :searchAffiliator_id' : '';
        $sql .= " ORDER BY p.{$sort} {$type}";
        $stmt = $this->mDb->connect()->prepare($sql);
        $searchTitle ? $stmt->bindValue(':searchTitle', '%' . $searchTitle . '%', PDO::PARAM_STR) : '';
        $searchAffiliator_id ? $stmt->bindValue(':searchAffiliator_id', '%' . $searchAffiliator_id . '%', PDO::PARAM_STR) : '';
        $stmt->execute();
        return $stmt->fetchColumn(0);
    }

    function getOffersCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `offers`";
        return $this->mDb->getOne($sql);
    }

    function getAlloffer_showing_type_options() {

        $sql = "SELECT * FROM offer_showing_type_options  ";
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function addx_get_yOffer($temp, $id) {

        $temp['x_ids'] = "," . fetchArrayValue_from_dataBase($temp['x_ids'], 'id') . ",";
        $temp['y_ids'] = "," . fetchArrayValue_from_dataBase($temp['y_ids'], 'id') . ",";

        $temp['y_discount_percentage_value'] = $temp['y_discount_percentage_value'] == 'free' ? '0' : $temp['y_discount_percentage_value'];

        $sql = "INSERT INTO `offer_x_y` SET ";
        foreach ($this->mDb->getCols('offer_x_y', $temp) as $k => $v) {
            $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'offer_id') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `offer_id` = '{$id}'";
        //  p($sql) ; 

        $this->mDb->query($sql);
    }

    function addNormalOffer($temp, $id) {

        //offer_discount: {
        // 					value: undefined,//float NOT NULL COMMENT 'قيمة الخصم تكون نسبة او ممكن تكون قيم ثابتة وهذ يحدد جدول العروض',
        // 					maximum_discount_value: undefined,// int(11) NOT NULL COMMENT 'اذا كانت نوع الخصم نسبة يجب تحديد حد اقصى للقيم ',
        // 					apply_type_conditions: "products",// enum('cart','products','services') NOT NULL COMMENT 'اول نوع لكل المنتجات في السلة الثاني منتجات محددة الثالث في اقسام محددة',
        // 					ids: [],  // text NOT NULL,
        // 					offer_application_type: "amount_of_prod",// enum('amount_of_prod','purchase_amount') NOT NULL COMMENT 'نوع تطبيق العرض هل هو عدد منتجات او قيمة شرائية',
        // 					minimum_value_offer_application: undefined// float NOT NULL COMMENT 'الحد الأدنى لتطبيق العرض سواء سعر او عدد منتجات'
        // 				}


        if ($temp['offer_on'] == "form_shapes") {
            $temp['offer_on_id'] = json_encode($temp['offer_on_id'][0]);
        } else if ($temp['offer_on'] == "trademarks" || $temp['offer_on'] == "products" || $temp['offer_on'] == "selected_products") {
            $temp['offer_on_id'] = "," . fetchArrayValue_from_dataBase($temp['offer_on_id'], 'id') . ",";
        } else if ($temp['offer_on'] == "external_link") {
            $temp['offer_on_id'] = $temp['offer_on_id'];
        } else {
            $temp['offer_on_id'] = "," . fetchArrayValue($temp['offer_on_id'], 'id') . ",";
        }


        $sql = "INSERT INTO `offer_normal` SET ";
        foreach ($this->mDb->getCols('offer_normal', $temp) as $k => $v) {
            $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'offer_id') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `offer_id` = '{$id}'";
        //  echo $sql ; die();
        $this->mDb->query($sql);
    }

    function addDiscountOffer($temp, $id, $type) {

        //offer_discount: {
        // 					value: undefined,//float NOT NULL COMMENT 'قيمة الخصم تكون نسبة او ممكن تكون قيم ثابتة وهذ يحدد جدول العروض',
        // 					maximum_discount_value: undefined,// int(11) NOT NULL COMMENT 'اذا كانت نوع الخصم نسبة يجب تحديد حد اقصى للقيم ',
        // 					apply_type_conditions: "products",// enum('cart','products','services') NOT NULL COMMENT 'اول نوع لكل المنتجات في السلة الثاني منتجات محددة الثالث في اقسام محددة',
        // 					ids: [],  // text NOT NULL,
        // 					offer_application_type: "amount_of_prod",// enum('amount_of_prod','purchase_amount') NOT NULL COMMENT 'نوع تطبيق العرض هل هو عدد منتجات او قيمة شرائية',
        // 					minimum_value_offer_application: undefined// float NOT NULL COMMENT 'الحد الأدنى لتطبيق العرض سواء سعر او عدد منتجات'
        // 				}




        $temp['ids'] = "," . fetchArrayValue_from_dataBase($temp['ids'], 'id') . ",";
        $temp['maximum_discount_value'] = $type == 'discount_percentage' ? $temp['maximum_discount_value'] : '0';
        $sql = "INSERT INTO `offer_discount` SET ";
        foreach ($this->mDb->getCols('offer_discount', $temp) as $k => $v) {
            $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'offer_id') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `offer_id` = '{$id}'";
        // echo $sql ; die();
        $this->mDb->query($sql);
    }

    function addEditOffer($temp) {
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['package'] = $temp['package'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';
        $temp['mode_banner'] = $temp['mode_banner'] ? $temp['mode_banner'] : '0';
        $temp['mode_offer'] = $temp['mode_offer'] ? $temp['mode_offer'] : '0';
        $temp['show_client'] = $temp['show_client'] ? $temp['show_client'] : '0';
        $temp['show_visitor'] = $temp['show_visitor'] ? $temp['show_visitor'] : '0';
        $temp['show_end_date'] = $temp['show_end_date'] ? $temp['show_end_date'] : '0';

        $temp['show_on_places'] = implode(",", $temp['show_on_places']);

        if ($temp['offer_start_date']) {
            $temp['offer_start_date'] = date_format(date_create($temp['offer_start_date']), "Y-m-d");
        } else {
            unset($temp['offer_start_date']);
        }
        if ($temp['offer_end_date']) {
            $temp['offer_end_date'] = date_format(date_create($temp['offer_end_date']), "Y-m-d");
        } else {
            unset($temp['offer_end_date']);
        }


        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `offers` SET ";
            foreach ($this->mDb->getCols('offers', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";
            // die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `offer_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}' , offer_id='{$id}'  , description = '{$v['details']['description']}' , attachment_single = '{$v['details']['attachment_single']}'   ";
                    //   echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                // x_y_type: {
                // 	x_types: "products",  // enum('products','services') NOT NULL DEFAULT 'products' COMMENT 'نوع المنتجات المخصصة لشرط العرض هل هي منتجات ام خدمات',
                // 	x_ids: [],  //text NOT NULL COMMENT 'اديهات المتجات او الخدمات',
                // 	x_quantity: undefined, //int(11) NOT NULL COMMENT 'الحد الادنى الذي سيتطبق عليه العرض',
                // 	y_types: "products", //enum('products','services') NOT NULL DEFAULT 'products',
                // 	y_ids: [],
                // 	y_quantity: undefined,
                // 	y_discount_type: "percentage",//enum('free','percentage') NOT NULL DEFAULT 'free' COMMENT 'نوع الخصم المطبق على المنتجات y',
                // 	y_discount_percentage_value: undefined  // float NOT NULL COMMENT 'قيمة نسبة الخصم',
                // },
                // 				offer_discount: {
                // 					value: undefined,//float NOT NULL COMMENT 'قيمة الخصم تكون نسبة او ممكن تكون قيم ثابتة وهذ يحدد جدول العروض',
                // 					maximum_discount_value: undefined,// int(11) NOT NULL COMMENT 'اذا كانت نوع الخصم نسبة يجب تحديد حد اقصى للقيم ',
                // 					apply_type_conditions: "products",// enum('cart','products','services') NOT NULL COMMENT 'اول نوع لكل المنتجات في السلة الثاني منتجات محددة الثالث في اقسام محددة',
                // 					ids: [],  // text NOT NULL,
                // 					offer_application_type: "amount_of_prod",// enum('amount_of_prod','purchase_amount') NOT NULL COMMENT 'نوع تطبيق العرض هل هو عدد منتجات او قيمة شرائية',
                // 					minimum_value_offer_application: undefined// float NOT NULL COMMENT 'الحد الأدنى لتطبيق العرض سواء سعر او عدد منتجات'
                // 				}
                // 				offer_id ='{$offer_id}'
                // 				x_get_y
                // discount_percentage
                // discount_constant

                if ($temp['offer_type'] == 'x_get_y') {
                    $this->addx_get_yOffer($temp['x_y_type'], $id);
                } else if ($temp['offer_type'] == 'discount_percentage' || $temp['offer_type'] == 'discount_constant') {
                    $this->addDiscountOffer($temp['offer_discount'], $id, $temp['offer_type']);
                } else if ($temp['offer_type'] == 'offer_normal') {
                    $this->addNormalOffer($temp['offer_normal'], $id);
                }
                # code...
            }
            return $res;
        } else {

            // edit
            $images = $this->getimg($temp['id']);
            //remove image 
            if ($temp['image'] == '') {
                $old_image = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image'];
                if (file_exists($old_image)) {
                    @unlink($old_image);
                }
            }
            //remove image_en
            if ($temp['image_en'] == '') {
                $old_image_en = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_en'];
                if (file_exists($old_image_en)) {
                    @unlink($old_image_en);
                }
            }
            //remove image_page_top
            if ($temp['image_page_top'] == '') {
                $old_image_page_top = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_page_top'];
                if (file_exists($old_image_page_top)) {
                    @unlink($old_image_page_top);
                }
            }
            //remove image_page_top_en
            if ($temp['image_page_top_en'] == '') {
                $old_image_page_top_en = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_page_top_en'];
                if (file_exists($old_image_page_top_en)) {
                    @unlink($old_image_page_top_en);
                }
            }

            $sql = "UPDATE `offers` SET ";
            foreach ($this->mDb->getCols('offers', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {




                $this->deletex_get_yOffer($temp['id']);
                $this->deleteDiscountOffer($temp['id']);
                $this->deleteNormalOffer($temp['id']);

                if ($temp['offer_type'] == 'x_get_y') {
                    $this->addx_get_yOffer($temp['x_y_type'], $temp['id']);
                } else if ($temp['offer_type'] == 'discount_percentage' || $temp['offer_type'] == 'discount_constant') {
                    $this->addDiscountOffer($temp['offer_discount'], $temp['id'], $temp['offer_type']);
                } else if ($temp['offer_type'] == 'offer_normal') {
                    $this->addNormalOffer($temp['offer_normal'], $temp['id']);
                }
                //delete lang_details
                $sql = "DELETE FROM `offer_langs` ";
                $sql .= " WHERE offer_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `offer_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,offer_id='{$temp['id']}'  , description = '{$v['details']['description']}' , attachment_single = '{$v['details']['attachment_single']}'    ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    public function deletex_get_yOffer($offer_id) {
        $sql = "DELETE From `{$this->mPrefix}offer_x_y`   ";
        $sql .= "where offer_id ='{$offer_id}'   ";
        $this->mDb->query($sql);
    }

    public function deleteDiscountOffer($offer_id) {
        $sql = "DELETE From `{$this->mPrefix}offer_discount`   ";
        $sql .= "where offer_id ='{$offer_id}'   ";
        $this->mDb->query($sql);
    }

    public function deleteNormalOffer($offer_id) {
        $sql = "DELETE From `{$this->mPrefix}offer_normal`   ";
        $sql .= "where offer_id ='{$offer_id}'   ";
        $this->mDb->query($sql);
    }

    public function getOneOffer($id) {
        $sql = "SELECT 
                    b.* , 
                    u2.user_name AS 'affiliator_name'  
                FROM offers b
                LEFT JOIN users u2 ON u2.id = b.affiliator_id
                WHERE b.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res) {
            $sql = "SELECT 
                        lang_code ,
                        title , 
                        description ,
                        attachment_single 
                    FROM offer_langs
                    WHERE offer_id = :offer_id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':offer_id', $id, PDO::PARAM_INT);
            $stmt->execute();
            $res['lang_parameter'] = $stmt->fetchAll(PDO::FETCH_ASSOC);
            if ($res['offer_type'] == 'x_get_y') {
                $sql = "SELECT * FROM offer_x_y
                        WHERE offer_id = :offer_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':offer_id', $id, PDO::PARAM_INT);
                $stmt->execute();
                $res['x_y_type'] = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($res['x_y_type']) {
                    if ($res['x_y_type']['x_types'] == 'products') {
                        $res['x_y_type']['x_ids'] = $this->get_products_name_by_ids($res['x_y_type']['x_ids']);
                    } else if ($res['x_y_type']['x_types'] == 'services') {
                        $res['x_y_type']['x_ids'] = $this->get_services_name_by_ids($res['x_y_type']['x_ids']);
                    } else if ($res['x_y_type']['x_types'] == 'trademarks') {
                        $res['x_y_type']['x_ids'] = $this->get_trademarks_name_by_ids($res['x_y_type']['x_ids']);
                    } else if ($res['x_y_type']['x_types'] == 'tags') {
                        $res['x_y_type']['x_ids'] = $this->get_tags_name_by_ids($res['x_y_type']['x_ids']);
                    } else if ($res['x_y_type']['x_types'] == 'product_group') {
                        $res['x_y_type']['x_ids'] = $this->get_products_groups_name_by_ids($res['x_y_type']['x_ids']);
                    }

                    if ($res['x_y_type']['y_types'] == 'products') {
                        $res['x_y_type']['y_ids'] = $this->get_products_name_by_ids($res['x_y_type']['y_ids']);
                    } else if ($res['x_y_type']['y_types'] == 'services') {
                        $res['x_y_type']['y_ids'] = $this->get_services_name_by_ids($res['x_y_type']['y_ids']);
                    } else if ($res['x_y_type']['y_types'] == 'trademarks') {
                        $res['x_y_type']['y_ids'] = $this->get_trademarks_name_by_ids($res['x_y_type']['y_ids']);
                    } else if ($res['x_y_type']['y_types'] == 'tags') {
                        $res['x_y_type']['y_ids'] = $this->get_tags_name_by_ids($res['x_y_type']['y_ids']);
                    } else if ($res['x_y_type']['y_types'] == 'product_group') {
                        $res['x_y_type']['y_ids'] = $this->get_products_groups_name_by_ids($res['x_y_type']['y_ids']);
                    }
                }
            } else if ($res['offer_type'] == 'discount_percentage' || $res['offer_type'] == 'discount_constant') {

                $sql = "SELECT * FROM offer_discount
                        WHERE offer_id = :offer_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':offer_id', $id, PDO::PARAM_INT);
                $stmt->execute();
                $res['offer_discount'] = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($res['offer_discount']) {

                    if ($res['offer_discount']['apply_type_conditions'] == 'products') {
                        $res['offer_discount']['ids'] = $this->get_products_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'services') {
                        $res['offer_discount']['ids'] = $this->get_services_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'trademarks') {
                        $res['offer_discount']['ids'] = $this->get_trademarks_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'tags') {
                        $res['offer_discount']['ids'] = $this->get_tags_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'product_group') {
                        $res['offer_discount']['ids'] = $this->get_products_groups_name_by_ids($res['offer_discount']['ids']);
                    }
                }
            } else if ($res['offer_type'] == 'offer_normal') {
                $sql = "SELECT * FROM offer_normal
                        WHERE offer_id = :offer_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':offer_id', $id, PDO::PARAM_INT);
                $stmt->execute();
                $res['offer_normal'] = $stmt->fetch(PDO::FETCH_ASSOC);
                if ($res['offer_normal']) {

                    if ($res['offer_normal']['offer_on'] == 'products' || $res['offer_normal']['offer_on'] == 'selected_products') {
                        $res['offer_normal']['offer_on_id'] = $this->get_products_name_by_ids($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_normal']['offer_on'] == 'services') {
                        $res['offer_normal']['offer_on_data'] = $this->get_services_name_by_offer_on_id($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_normal']['offer_on'] == 'pages_support_center_and_blog') {
                        $res['offer_normal']['offer_data'] = $this->get_pages_support_center_and_blog_by_ids($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_normal']['offer_on'] == 'trademarks') {
                        $res['offer_normal']['offer_on_id'] = $this->get_trademarks_name_by_ids($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'tags') {
                        $res['offer_discount']['offer_on_data'] = $this->get_tags_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_discount']['apply_type_conditions'] == 'product_group') {
                        $res['offer_discount']['offer_on_data'] = $this->get_products_groups_name_by_ids($res['offer_discount']['ids']);
                    } else if ($res['offer_normal']['offer_on'] == 'form_shapes') {
                        $res['offer_normal']['offer_on_id'] = json_decode($res['offer_normal']['offer_on_id']);
                    }
                }
            }

            $res['show_on_places'] = explode(",", $res['show_on_places']);
        }
        return $res;
    }

    public function checkIfExistPriority($affiliator_id, $priority, $id) {
        $sql = "SELECT priority FROM  `offers`  where id  >  0 ";
        $sql .= $affiliator_id ? " AND `affiliator_id` ='{$affiliator_id}' " : " ";
        $sql .= $id ? " AND `id` !='{$id}' " : " ";
        $sql .= " order by priority asc   ";

        $res['priorities'] = $this->mDb->getAll($sql);
        $res['is_exist'] = array_search($priority, array_column($res['priorities'], 'priority'));
        $res['priorities_string'] = fetchArrayValue_from_dataBase($res['priorities'], 'priority');
        // p($res);
        // echo $sql;
        // die();
        return $res ? $res : array();
    }

    public function get_trademarks_name_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT title , trademark_id as id  FROM  `trademark_langs`  ";
        $sql .= " WHERE  trademark_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_services_name_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT ser_name , service_id as id  FROM  `service_langs`  ";
        $sql .= " WHERE  service_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_pages_support_center_and_blog_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT sabp.id,sabp.parent ,sabp.cat_id,sabpl.title FROM  `support_and_blog_pages` sabp  ";
        $sql .= " LEFT JOIN `support_and_blog_pages_langs` sabpl ON sabpl.page_id = sabp.id  and  sabpl.lang_code = '{$this->lang_code}'";
        $sql .= " WHERE  sabp.id  in  ({$ids})    ";
        $res = $this->mDb->getRow($sql);
//		  echo $sql;
        //   die();
        return $res ? $res : '';
    }

    public function get_services_name_by_offer_on_id($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT s.id,s.parent ,sl.ser_name FROM  `services` s  ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = s.id  and  sl.lang_code = '{$this->lang_code}'";
        $sql .= " WHERE  s.id  in  ({$ids})    ";
        $res = $this->mDb->getRow($sql);
//		  echo $sql;
        //   die();
        return $res ? $res : '';
    }

    public function get_products_name_by_ids($ids) {


        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT  pl.name ,p.price_one , p.price_multi ,p.id  FROM  `products` p  ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = 'ar'";

        $sql .= " WHERE  p.id  in  ({$ids}) ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['store_amounts'] = $this->productsObj->getProductStoreAmounts($res[$i]['id']);
            $res[$i]['images'] = $this->productsObj->getProductimgs($res[$i]['id']);
            $res[$i]['image'] = $res[$i]['images'][0]['name'];
        }
        //  echo $sql;
        return $res ? $res : array();
    }

    function getimg($id) {
        $sql = "SELECT `image`,`image_en`,`image_page_top`,`image_page_top_en` FROM `offers`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getRow($sql);
    }

    function deleteOffer($ids) {

        $sql = "DELETE FROM `offers` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $images = $this->getimg($id);
            ////////image
            $old_image = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image'];
            if (file_exists($old_image)) {
                @unlink($old_image);
            }
            /////// image_en
            $old_image_en = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_en'];
            if (file_exists($old_image_en)) {
                @unlink($old_image_en);
            }
            ///////image_page_top
            $old_image_page_top = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_page_top'];
            if (file_exists($old_image_page_top)) {
                @unlink($old_image_page_top);
            }
            ///////image_page_top_en
            $old_image_page_top_en = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/offers/' . $images['image_page_top_en'];
            if (file_exists($old_image_page_top_en)) {
                @unlink($old_image_page_top_en);
            }


            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    public function get_tags_name_by_ids($ids) {
        $ids = trim($ids, '()');
        $idsArray = explode(',', $ids);
        $placeholders = implode(',', array_map(function ($key) {
                    return ":id" . $key;
                }, array_keys($idsArray)));
        $sql = "SELECT label , tag_id as id 
                FROM tags_langs 
                WHERE tag_id IN ($placeholders) 
                AND lang_code = :lang_code";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($idsArray as $key => $id) {
            $stmt->bindValue(":id" . $key, trim($id), PDO::PARAM_INT);
        }
        $stmt->bindValue(":lang_code", $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : [];
    }

    public function get_products_groups_name_by_ids($ids) {
        $ids = trim($ids, '()');
        $idsArray = explode(',', $ids);
        $placeholders = implode(',', array_map(function ($key) {
                    return ":id" . $key;
                }, array_keys($idsArray)));
        $sql = "SELECT name , p_id as id 
                FROM groups_langs 
                WHERE p_id IN ($placeholders) 
                AND lang_code = :lang_code";
        $stmt = $this->mDb->connect()->prepare($sql);
        foreach ($idsArray as $key => $id) {
            $stmt->bindValue(":id" . $key, trim($id), PDO::PARAM_INT);
        }
        $stmt->bindValue(":lang_code", $this->lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res ? $res : [];
    }
}
