<?php

$placesObj = new Places();

class Places {

    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;
        // global LANGUAGE;
        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'ar'; // تأكد من تعريف LANGUAGE
    }

    function getPlacesByParams($aStart, $aLimit, $sort, $type, $searchName = '', $parent_id = 0, $city_id = 0, $place_type = '', $shipment_id = '', $id = '', $affiliator_id = '') {
        // echo "$parent_id";die();
        $sql = "SELECT p.* , pl.pla_name  ,pl2.pla_name as country_name ,pl21.pla_name as city_name, u.user_name AS 'addedBy' FROM places p ";
        $sql .= " LEFT JOIN `users` u ON u.id = p.admin_id ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `place_langs` pl2 ON p.country_id = pl2.place_id AND pl2.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `place_langs` pl21 ON p.city_id = pl21.place_id AND pl21.lang_code = '{$this->lang_code}' ";

        $sql .= " WHERE p.id > 0  ";
        $sql .= $searchName ? ' AND pl.pla_name like "%' . $searchName . '%"   ' : '';

        $sql .= $place_type ? " AND p.place_type = '{$place_type}' " : '';

        $sql .= $parent_id ? " AND p.country_id  = '{$parent_id}'  " : '';
        $sql .= $city_id ? " AND p.city_id  = '{$city_id}'  " : '';

        $sql .= $id && $place_type == '' ? " AND p.id = '{$id}' ||  p.country_id  = '{$id}' " : "";
        $sql .= $id && $place_type == 'country' ? " AND p.id = '{$id}'" : "";
        $sql .= " Group by p.id  ";
        $sql .= $sort ? " ORDER BY pl.{$sort} {$type} " : ' ORDER BY p.id desc ';

        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//            echo $sql."<hr>";

        $res = $this->masterDb->getAll($sql);
        if ($res && $place_type == 'city') {
            for ($i = 0; $i < count($res); $i++) {
             
                $row = $this->getDelivery_price($res[$i]['id'], $shipment_id, $affiliator_id);
                if (isset($row) && $row) {
                    $res[$i]['delivery_price'] = $row['customer_price'] ? $row['customer_price'] : '0';
                    $res[$i]['shipment_value'] = $row['store_price'] ? $row['store_price'] : '0';
                    $res[$i]['shipment_company'] = $row['name'] ? $row['name'] : '';
                    $res[$i]['shipment_id'] = $row['id'];
                }
            }
        }

        return $res;
    }

    function getAllPlacesByDistrict($aStart, $aLimit, $sort, $type, $searchName = '', $parent_id = 0, $city_id = 0, $place_type = '') {
        // echo "$parent_id";die();
        $sql = "SELECT p.id , pl.pla_name  FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE p.id > 0  ";
        $sql .= $searchName ? ' AND pl.pla_name like "%' . $searchName . '%"   ' : '';
        $sql .= $place_type ? " AND p.place_type = '{$place_type}' " : '';
        $sql .= $parent_id ? " AND p.country_id  = '{$parent_id}'  " : '';
        $sql .= $city_id ? " AND p.city_id  = '{$city_id}'  " : '';

        $sql .= " Group by p.id  ";
        $sql .= $sort ? " ORDER BY pl.{$sort} {$type} " : ' ORDER BY p.id desc ';

        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//            echo $sql."<hr>";

        $res = $this->masterDb->getAll($sql);

        return $res;
    }

    function getAllPlacesByParentAndType($parent_id = 0, $city_id = '', $place_type = '') {

        $sql = "SELECT p.id , pl.pla_name  FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE p.active='1'  ";

        $sql .= $place_type ? " AND p.place_type = '{$place_type}' " : '';
        $sql .= $parent_id ? " AND p.country_id  = '{$parent_id}'  " : '';
        $sql .= $city_id ? " AND p.city_id  = '{$city_id}'  " : '';

        $sql .= " Group by p.id  ";
        $sql .= ' ORDER BY p.id desc ';

        // echo LANGUAGE ;die();
//        echo $sql . "<hr>";

        $res = $this->masterDb->getAll($sql);
//        if ($res) {
//            for ($i = 0; $i < count($res); $i++) {
//                $row = $this->getDelivery_price($res[$i]['id'], $shipment_id);
//                $res[$i]['delivery_price'] = $row['customer_price'] ? $row['customer_price'] : '0';
//                $res[$i]['shipment_value'] = $row['store_price'] ? $row['store_price'] : '0';
//                $res[$i]['shipment_company'] = $row['name'] ? $row['name'] : '';
//                $res[$i]['shipment_id'] = $row['id'];
//            }
//        }

        return $res;
    }

    function getPlacesExcel($parent_id = 0, $place_type = '', $id = '') {
        $sql = "SELECT p.id , pl.pla_name as name,p.active   FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE p.id > 0  ";
        $sql .= $place_type ? " AND p.place_type = '{$place_type}' " : '';
        $sql .= ($place_type == 'city' && !$id ) ? " AND p.country_id  = '{$parent_id}'  " : '';

        $sql .= $id ? " AND  p.`id` = '{$id}' " : " ";
        $sql .= $id ? " " : " Group by p.id  ORDER BY p.id ASC";

//        echo $sql . "<hr>";
        if ($id) {
            return $this->masterDb->getRow($sql);
        } else {
            return $this->masterDb->getAll($sql);
        }
    }

    public function getCustomerPrice($id, $affiliator_id = '') {

        $sql = "SELECT price FROM `{$this->mPrefix}shipping_methods_governorate_customer_price` ";
        $sql .= "WHERE `affiliator_id`='{$affiliator_id}' and p_id = '{$id}' ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

    public function getDelivery_price($id, $shipment_id, $affiliator_id = '') {
//        $sql = "SELECT delivery_price FROM `places` ";
//        $sql .= " WHERE id = '{$id}'  ";
//        $res = $this->mDb->getOne($sql);
//        
//        
//        

        $sql = " SELECT sm.id,sm.default_shipping_method, smg.id gov_id, smg.store_price, sml.name FROM `shipping_methods_governorate` smg ";
        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id  ";
        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE smg.governorate_id = '{$id}'";
        $sql .= $shipment_id ? " and  sm.id = '{$shipment_id}'   " : " AND (sm.default_shipping_method = '1') ";
        $sql .= " OR ( sm.default_shipping_method = '0'  AND NOT EXISTS ( ";
        $sql .= " SELECT 1  FROM `shipping_methods_governorate` smg_inner ";
        $sql .= " LEFT JOIN `shipping_methods` sm_inner ON sm_inner.id = smg_inner.p_id  ";
        $sql .= " WHERE smg_inner.governorate_id = '{$id}' AND sm_inner.default_shipping_method = '1' ";
        $sql .= " )) LIMIT 1 ";

//        $sql = "SELECT sm.id,smg.customer_price,smg.store_price,sml.name FROM `shipping_methods_governorate` smg ";
//        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id    ";
//        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'   ";
//        $sql .= " WHERE smg.governorate_id = '{$id}'  ";
//        $sql .= $shipment_id ? " and  sm.id = '{$shipment_id}'   " : "  and (sm.default_shipping_method='1' || sm.default_shipping_method='0')  ";
//       echo $sql . "<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['customer_price'] = $this->getCustomerPrice($res['gov_id'], $affiliator_id);
        }
        return $res;
    }

    function getSearchplacesCount($searchName = '', $parent_id = 0, $city_id = 0, $place_type = '', $id = '') {
        $sql = "SELECT COUNT(DISTINCT p.id) as 'result_count' FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id ";

        $sql .= " WHERE p.id > 0 AND pl.lang_code = '{$this->lang_code}' ";

        $sql .= $place_type ? " AND p.place_type = '{$place_type}' " : '';
        $sql .= $parent_id ? " AND p.country_id  = '{$parent_id}'  " : '';
        $sql .= $city_id ? " AND p.city_id  = '{$city_id}'  " : '';

        $sql .= $searchName ? ' AND pl.pla_name like "%' . $searchName . '%"   ' : '';

        $sql .= $id && $place_type == '' ? " AND p.id = '{$id}' ||  p.country_id  = '{$id}' " : "";
        $sql .= $id && $place_type == 'country' ? " AND p.id = '{$id}'" : "";
//       echo $sql."<hr>";

        return $this->masterDb->getOne($sql);
    }

    function addEditPlace($temp) {

        $temp['active'] = $temp['active'] ? '1' : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `places` SET ";
            foreach ($this->masterDb->getCols('places', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->masterDb->query($sql);
            if ($res) {
                $id = $this->masterDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `place_langs` SET  lang_code = '{$v['lang_code']}' , pla_name = '{$v['details']['pla_name']}', currency = '{$v['details']['currency']}'  ,place_id='{$id}' ";
                    $sql .= " ,`date_added` = '{$this->dateTime}'";

                    // echo "$sql";die();
                    $res2 = $this->masterDb->query($sql);
                }

                # code...
            }
            return $res;
        } else {




            $sql = "UPDATE `places` SET ";
            foreach ($this->masterDb->getCols('places', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->masterDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `place_langs` ";
                $sql .= " WHERE place_id='{$temp['id']}'  ";
                $res2 = $this->masterDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `place_langs` SET  lang_code = '{$v['lang_code']}' , pla_name = '{$v['details']['pla_name']}', currency = '{$v['details']['currency']}'   ,place_id='{$temp['id']}' ";
                    $sql .= " ,`date_added` = '{$this->dateTime}'";
// echo "$sql";die();
                    $res2 = $this->masterDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    function getOnePlace($id) {
        $sql = "SELECT * FROM `places`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->masterDb->getRow($sql);
        if ($res) {
            $res['active'] = $res['active'] ? 1 : 0;
            $sql = "SELECT lang_code ,pla_name,currency  FROM `place_langs`";
            $sql .= " WHERE `place_id` = '{$id}' ";
            $res['lang_parameter'] = $this->masterDb->getAll($sql);
        }
        //   echo "<pre>";print_r($res);die();
        return $res;
    }

    public function getOnePlaceDetails($id) {
        $sql = "SELECT `p`.* , pl_ar.pla_name FROM `places` p ";
        //   sl.ser_name   ******************************************
        $sql .= " LEFT JOIN `place_langs` pl_ar ON pl_ar.place_id = p.id  AND  pl_ar.lang_code = 'ar'";
        $sql .= " WHERE p.id = '{$id}'    ";
        $res = $this->masterDb->getRow($sql);
        // echo "<pre>";
        // print_r($sql);die();
        return $res;
    }

    public function getShipmentByParams() {
        $sql = "SELECT `sm`.* , sml.name FROM `shipping_methods` sm ";

        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sml.p_id = sm.id  AND  sml.lang_code = 'ar'";

        $res = $this->mDb->getAll($sql);
        return $res;
    }

    function deletePlace($ids) {

        $sql = "DELETE FROM `places` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $sql .= " || `id` = '{$id}' || `country_id` = '{$id}'    ";
        }
        // echo "$sql";die();

        return $this->masterDb->query($sql);
    }

    function getPlacesOptions($aStart, $aLimit, $sort, $type) {
        // echo "$parent_id";die();
        $sql = "SELECT p.id , pl.pla_name as name  FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE p.id > 0 and p.place_type='city' ";
        $sql .= " Group by p.id  ";
        $sql .= $sort ? " ORDER BY pl.{$sort} {$type} " : ' ORDER BY p.id desc ';
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
        //    echo $sql; die();

        $res = $this->masterDb->getAll($sql);

        return $res;
    }
}
