<?php

$settingApi = new settingApi();

class settingApi {

    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function cheackIfExitByFieldAndTable($value, $field, $table, $id) {
//add by ahmadklsany
        $sql = "SELECT  id FROM `{$table}`   ";
        $sql .= " WHERE {$field} = '{$value}'  ";
        $sql .= $id ? " AND id != '{$id}' " : '';
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getSomeAllData($aStart, $aLimit, $sort, $type, $searchName, $searchSecretkey) {

        $sql = "SELECT sa.*, u.user_name AS 'added_by'";
        $sql .= " FROM `setting_api` sa ";
        $sql .= " LEFT JOIN `users` u ON u.id = sa.admin_id ";
        $sql .= " WHERE sa.id > 0";
        $sql .= $searchName ? ' AND sa.name like "%' . $searchName . '%"' : '';
        $sql .= $searchSecretkey ? " AND sa.secret_key = '{$searchSecretkey}'" : '';
        $sql .= " GROUP BY sa.`id`";
        $sql .= " ORDER BY sa.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql; die();
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getSearchAllDataCount($searchName = '', $searchSecretkey = '') {

        $sql = "SELECT COUNT(DISTINCT sa.`id`) as 'result_count' FROM setting_api sa ";
        $sql .= " WHERE sa.id > 0";
        $sql .= $searchName ? ' AND sa.`name` like "%' . $searchName . '%"' : '';
        $sql .= $searchSecretkey ? " AND sa.secret_key = '{$searchSecretkey}'" : '';
        // echo   $sql; die();
        return $this->mDb->getOne($sql);
    }

    public function updateSecretKey($id, $secretKey) {
        $sql = " UPDATE `setting_api` SET `secret_key` = '{$secretKey}'";
        $sql .= " WHERE `id` = '{$id}'";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function addSettingApiSections($sections, $p_id) {
        if (count($sections) > 0) {
            foreach ($sections as $v) {
                if ($v['cat_id']) {
                    $sql = "INSERT INTO `{$this->mPrefix}setting_api_sections` 
                (p_id, parent, cat_id, deleted, date_added) VALUES ";
                    $sql .= "('$p_id', '{$v['parent']}', '{$v['cat_id']}', '{$v['deleted']}', '{$this->dateTime}')";
                    $res = $this->mDb->query($sql);
                    if ($res && $v['deleted'] == '1') {
                        $this->updateSharingSectionsByIdFrom($p_id, $v);
                    }
                }
            }
        }
        return $res;
    }

    public function addSettingApiStores($stores, $p_id) {
        if (count($stores) > 0) {
            $sql = "INSERT INTO `{$this->mPrefix}setting_api_stores` 
                (p_id, store_id, deleted, date_added) VALUES ";
            foreach ($stores as $v) {
                if ($v['store_id']) {
                    $sql .= "('$p_id', '{$v['store_id']}',  '{$v['deleted']}', '{$this->dateTime}'),";
                }
            }
            $sql = substr($sql, 0, -1);
            $res = $this->mDb->query($sql);
        }
        return $res;
    }

    public function deleteSettingApiSections($p_id) {
        $sql = "DELETE From `{$this->mPrefix}setting_api_sections`   ";
        $sql .= "where p_id ='{$p_id}'   ";
        $this->mDb->query($sql);
    }

    public function deleteSettingApiStores($p_id) {
        $sql = "DELETE From `{$this->mPrefix}setting_api_stores`   ";
        $sql .= "where p_id ='{$p_id}'   ";
        $this->mDb->query($sql);
    }

    public function addEditData($temp) {


        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['share_quantity_products'] = $temp['share_quantity_products'] ? '1' : '0';
        $temp['archive_products'] = $temp['archive_products'] ? '1' : '0';

        if (!$temp['id']) {
            $sql = "INSERT INTO `setting_api` SET ";
            foreach ($this->mDb->getCols('setting_api', $temp) as $k => $v) {
                $sql .= ( $k == 'id' || $k == 'sections' || $k == 'stores' || $k == 'secret_key') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}' ";
//  echo $sql; die();
            $id = $this->mDb->queryreturnlastid($sql);
            if ($id) {

                $this->updateSecretKey($id, $temp['dealer_name'] . '-' . md5($temp['dealer_id'] . '_' . $id));
                $this->addSettingApiSections($temp['sections'], $id);
                $this->addSettingApiStores($temp['stores'], $id);
            }


            return $id;
        } else {
//edit
            $sql = "UPDATE `setting_api` SET ";
            foreach ($this->mDb->getCols('setting_api', $temp) as $k => $v) {
                $sql .= ($k == 'id' || $k == 'sections' || $k == 'stores' || $k == 'secret_key' || $k == 'date_added') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
//           echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {
                //delete
                $this->deleteSettingApiSections($temp['id']);
                $this->deleteSettingApiStores($temp['id']);
                //add
                $this->addSettingApiSections($temp['sections'], $temp['id']);
                $this->addSettingApiStores($temp['stores'], $temp['id']);

                $this->updateSharingApiByIdFrom($temp);
            }
            return $res ? $temp['id'] : $res;
        }
    }

    public function getOneData($id) {
        global $productsObj;
        $sql = "SELECT  sa.*  FROM `setting_api` sa";
        $sql .= " WHERE sa.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['sections'] = $this->getAllSettingApiSections($res['id']);
            $res['stores'] = $this->getAllSettingApiStores($res['id']);
            $res['all_products_excluded'] = [];
            if ($res['excluded_products']) {
                $res['all_products_excluded'] = $productsObj->getAllProductsExcluded($res['excluded_products']);
            }
        }

        return $res;
    }

    public function getAllSettingApiSections($p_id) {
        $sql = "SELECT  *  FROM `{$this->mPrefix}setting_api_sections`   ";
        $sql .= "WHERE   p_id = '{$p_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function getAllSettingApiStores($p_id) {
        $sql = "SELECT  *  FROM `{$this->mPrefix}setting_api_stores`   ";
        $sql .= "WHERE   p_id = '{$p_id}' ";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : array();
    }

    public function deleteData($ids) {

        $idList = implode("','", $ids);

        $sql = "DELETE FROM `setting_api` WHERE  `id` IN ('$idList')";
        $sql_sections = "DELETE FROM `setting_api_sections` WHERE  `p_id` IN ('$idList')";
        $sql_stores = "DELETE FROM `setting_api_stores` WHERE  `p_id` IN ('$idList')";

        $sql_sharing_api = "UPDATE `sharing_api` SET  deleted_from='1',edit='1'  WHERE  `api_id_from` IN ('$idList')";

        $res = $this->mDb->query($sql);
        if ($res) {
            $this->mDb->query($sql_sections);
            $this->mDb->query($sql_stores);
            $this->mDb->query($sql_sharing_api);
        }

        return $res;
    }

    public function deleteDataSections($id) {
        $sql = "DELETE FROM `setting_api_sections` ";
        $sql .= " WHERE `p_id` = '{$id}' ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function deleteDataStores($id) {
        $sql = "DELETE FROM `setting_api_stores` ";
        $sql .= " WHERE `p_id` = '{$id}' ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function updateSharingApiByIdFrom($data) {
        $sql = " UPDATE `sharing_api` SET `share_quantity_products` = '{$data['share_quantity_products']}' ";
        $sql .= " , `archive_products` = '{$data['archive_products']}' ";
        $sql .= " , `excluded_products_from` = '{$data['excluded_products']}' ";
        $sql .= " , `active_from` = '{$data['active']}'  ";
        $sql .= " , `edit` = '1'  ";
        $sql .= " WHERE `api_id_from` = '{$data['id']}'";
//        echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        if ($res) {
//            if ($data['active'] == '0') {
//                $this->updateAllSharingSections($data['id'], '1');
//                $this->updateAllSharingStores($data['id'], '1');
//            } else {
//                $this->updateAllSharingSections($data['id'], '0');
//                $this->updateAllSharingStores($data['id'], '0');
//            }
        }

        return $res;
    }

    public function updateAllSharingStores($p_id, $deleted = '1') {
        $sql = " UPDATE `sharing_api_stores`  ss  ";
        $sql .= " LEFT JOIN `sharing_api` sa ON sa.id = ss.p_id ";
        $sql .= " SET ss.deleted='{$deleted}', ss.`edit` = '1'  ";
        $sql .= " WHERE sa.`api_id_from` = '{$p_id}'";
//        echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }

    public function updateAllSharingSections($p_id, $deleted) {
        $sql = " UPDATE `sharing_api_sections`  ss  ";
        $sql .= " LEFT JOIN `sharing_api` sa ON sa.id = ss.p_id ";
        $sql .= " SET ss.deleted='{$deleted}', ss.`edit` = '1'  ";
        $sql .= " WHERE sa.`api_id_from` = '{$p_id}'";
//        echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }

    public function updateSharingSectionsByIdFrom($p_id, $data) {
        $sql = " UPDATE `sharing_api_sections`  ss  ";
        $sql .= " LEFT JOIN `sharing_api` sa ON sa.id = ss.p_id ";
        $sql .= " SET ss.deleted='1', ss.`edit` = '1'  ";
        $sql .= " WHERE sa.`api_id_from` = '{$p_id}' and ss.parent_from='{$data['parent']}' and ss.cat_id_from='{$data['cat_id']}'";
//       echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }
}
