<?php

$storesObj = new stores();

class stores {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;
    public $productsObj;

    public function __construct() { // تعديل اسم الدالة إلى __construct
        global $Config;

        $this->productsObj = new Products();
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getStoresList($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id) {

        $sql = "SELECT t.id ,tl.title FROM stores t";
        $sql .= " LEFT JOIN `store_langs` tl ON t.id = tl.store_id ";
        $sql .= $searchAffiliator_id ? " LEFT JOIN `affiliator_stores` ast ON t.id = ast.store_id " : " ";
        $sql .= " WHERE t.id > 0  AND tl.lang_code ='{$this->lang_code}'  ";
        $sql .= $searchAffiliator_id ? " AND  ast.user_id = '{$searchAffiliator_id}' " : " ";
        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        $sql .= " AND  t.active = '1' and t.type='local' ";
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        //   echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getStores($aStart, $aLimit, $sort, $type, $searchTitle, $searchActive, $searchAffiliator_id, $seller_id = '') {

        $sql = "SELECT t.* ,tl.title,tl.title_share, u.user_name AS 'addedBy' FROM stores t";
        $sql .= " LEFT JOIN `store_langs` tl ON t.id = tl.store_id ";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
        $sql .= $searchAffiliator_id ? " LEFT JOIN `affiliator_stores` ast ON t.id = ast.store_id " : " ";
        $sql .= " WHERE t.id > 0  AND tl.lang_code ='{$this->lang_code}'  ";
        $sql .= $searchAffiliator_id ? " AND  ast.user_id = '{$searchAffiliator_id}' " : " ";
        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        $sql .= $searchActive ? " AND ( t.active = '{$searchActive}'  ) " : '';
        $sql .= $seller_id ? " AND  t.seller_id = '{$seller_id}'  " : '';

        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        //   echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchStoresCount($sort, $type, $searchTitle, $searchActive, $searchAffiliator_id, $seller_id = '') {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM stores t ";
        $sql .= " LEFT JOIN `store_langs` tl ON t.id = tl.store_id ";
        $sql .= $searchAffiliator_id ? " LEFT JOIN `affiliator_stores` ast ON t.id = ast.store_id " : " ";
        $sql .= " WHERE t.`id` > 0";
        $sql .= $searchAffiliator_id ? " AND ast.user_id = '{$searchAffiliator_id}' " : " ";

        $sql .= $searchTitle ? ' AND ( tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        $sql .= $searchActive ? " AND ( t.active = '{$searchActive}'  ) " : '';
        $sql .= $seller_id ? " AND  t.seller_id = '{$seller_id}'   " : '';

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getStoresCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `stores`";
        return $this->mDb->getOne($sql);
    }

    function addEditStore($temp) {
        global $userObj;
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['show_store_amounts'] = $temp['show_store_amounts'] ? '1' : '0';


        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `stores` SET ";
            foreach ($this->mDb->getCols('stores', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `store_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}', title_share = '{$v['details']['title_share']}' , description = '{$v['details']['description']}'   , store_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                $this->addStoreSellersAffiliators($temp['seller_affiliators'], $id);
                // اضافة الرفوف داخل المخزن
                $this->addStoreAdjustShelves($temp['adjust_shelves'], $id);

                if (!$temp['account_code'] && $temp['type'] == 'local') {

                    $accountInfo = $this->getAccountIdByTypeStores('warehouses');

                    if ($accountInfo) {
                        $accountInfo['admin_id'] = $res[$i]['admin_id'];
                        $account_code = $userObj->addAccount($accountInfo);
                        $this->updateAccountIdInStores($account_code, $id);
                    }
                }

                # code...
            }
            return $res;
        } else {

            $sql = "UPDATE `stores` SET ";
            foreach ($this->mDb->getCols('stores', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `store_langs` ";
                $sql .= " WHERE store_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `store_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}' , title_share = '{$v['details']['title_share']}' , description = '{$v['details']['description']}'   ,store_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }
                $this->addStoreSellersAffiliators($temp['seller_affiliators'], $temp['id']);
                // اضافة الرفوف داخل المخزن
                $this->addStoreAdjustShelves($temp['adjust_shelves'], $temp['id']);

                if (!$temp['account_code'] && $temp['type'] == 'local') {

                    $accountInfo = $this->getAccountIdByTypeStores('warehouses');

                    if ($accountInfo) {
                        $accountInfo['admin_id'] = $res[$i]['admin_id'];
                        $account_code = $userObj->addAccount($accountInfo);
                        $this->updateAccountIdInStores($account_code, $temp['id']);
                    }
                }


                # code...
            }

            return $res;
        }
    }

    public function updateAccountIdInStores($account_code, $id) {
        $sql = " UPDATE  `stores` SET `account_code` = '{$account_code}' ";
        $sql .= " WHERE `id` = '{$id}'  ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    public function addStoreSellersAffiliators($seller_affiliators, $id) {
        $this->deleteStoreSellersAffiliators($id);
        for ($i = 0; $i < count($seller_affiliators); $i++) {
            $sql = "INSERT INTO `store_sellers_affiliators` SET ";
            $sql .= "  `store_id`='{$id}',`affiliator_id`='{$seller_affiliators[$i]['affiliator_id']}',`seller_name`='{$seller_affiliators[$i]['seller_name']}' ";
            $sql .= " ,`date_added` = '{$this->dateTime}' ";
//   echo $sql;die();
            $this->mDb->query($sql);
        }
    }

    public function deleteStoreSellersAffiliators($store_id) {
        $sql = "DELETE  FROM `store_sellers_affiliators`  ";
        $sql .= " WHERE  store_id='{$store_id}' ";
//      echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
//    echo $sql ;die();
    }

    public function addStoreAdjustShelves($data, $id) {

        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["is_deleted"] == '1') {
                $this->deleteStoreAdjustShelves($data[$i], $id);
            } else {
                if (!$data[$i]["id"]) {
                    $sql = "INSERT INTO `store_adjust_shelves` SET ";
                    $sql .= "  `store_id`='{$id}',`name`='{$data[$i]['name']}',`sort`='{$data[$i]['sort']}' ";
                    $sql .= " ,`date_added` = '{$this->dateTime}' ";
//  echo $sql."<hr>";
                    $this->mDb->query($sql);
                } else {
                    $sql = "UPDATE `store_adjust_shelves` SET ";
                    $sql .= " `name`='{$data[$i]['name']}',`sort`='{$data[$i]['sort']}' ";
                    $sql .= " WHERE `id` = '{$data[$i]['id']}'";
//                     echo $sql."<hr>";
                    $this->mDb->query($sql);
                }
            }
        }
    }

    public function deleteStoreAdjustShelves($data, $store_id) {
        $sql = "DELETE  FROM `store_adjust_shelves`  ";
        $sql .= " WHERE  store_id='{$store_id}' and id='{$data['id']}' ";
//       echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
//    echo $sql ;die();
    }

    function getStoreSellersAffiliators($store_id) {
        $sql = "SELECT * FROM `store_sellers_affiliators`";
        $sql .= "WHERE   store_id= '{$store_id}' ";
        return $this->mDb->getAll($sql);
    }

    public function getAccountIdByTypeStores($type) {

        $sql = "SELECT   a.id as parent,a.code,'1' as account_type,'stores' as mode ,(SELECT count(id) FROM `{$this->mPrefix}accounts` WHERE parent = a.id) as code_count  FROM `{$this->mPrefix}accounts_routing_list` arl ";
        $sql .= " LEFT JOIN `accounts` a ON a.code = arl.account_code ";
        $sql .= "WHERE arl.routing_key = '{$type}' ";

        $res = $this->mDb->getRow($sql);
        $res['code'] = $res['code'] . ($res['code_count'] > '0' ? +$res['code_count'] + 1 : '1');
        $res['type'] = 'debtor';

        unset($res['code_count']);
//        echo $sql;
        return $res;
    }

    function getOneStore($id) {
        $sql = "SELECT * FROM `stores`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title,title_share,description FROM `store_langs`";
            $sql .= " WHERE `store_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);

            $res['seller_affiliators'] = $this->getStoreSellersAffiliators($res['id']);
            $res['seller_name'] = $this->getSellerNameBySellerId($res['seller_id']);
            $res['adjust_shelves'] = $this->getAdjustShelves($res['id']);
        }


        // echo "<pre>";print_r($res);die();
        return $res;
    }

    public function getSellerNameBySellerId($sellerId) {
        $sql = "SELECT name as seller_name  FROM sellers ";
        $sql .= " WHERE id='{$sellerId}'   ";
//       echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);
        return $res ? $res : '';
    }

    public function getAdjustShelves($store_id) {
        $sql = "SELECT * FROM store_adjust_shelves ";
        $sql .= " WHERE store_id='{$store_id}'   ";
        $sql .= "ORDER BY  sort ASC ";
//       echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        return $res ? $res : [];
    }

    function deleteStore($ids) {
        $sql = "DELETE FROM `stores` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function getStoresReport(
    $aStart = '', $aLimit = '', $sort = '', $type = '', $searchDateFrom='', $searchDateTo='', $searchKey='', $searchStore_id='', $searchTrademark_id='', $searchServiceId='', $searchStatusStock=''
    ) {


        if ($searchStatusStock) {
            $data = $this->getSearchStoresReportCount(
                    $searchDateFrom, $searchDateTo, $searchKey, $searchStore_id, $searchTrademark_id, $searchServiceId, $searchStatusStock
            );
            $ids = $data['ids'];
        }



        $sql = "SELECT   p.id , p.price , p.commission ,  p.system_commission ,  p.merchant_supply ,  p.price_gomla_gomla , p.price_multi , p.price_half , p.price_one , p.cost , p.product_code ,p.product_barcode ,   sl.title as store_title ,  pl.name as product_name  , tl.title as trademark_title FROM `product_stores` ps";
        $sql .= " LEFT JOIN `store_langs` sl ON sl.store_id = ps.store_id   AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `products` p ON p.id = ps.product_id ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id   AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `product_services` pse ON pse.product_id = ps.product_id ";
        $sql .= " LEFT JOIN `trademark_langs` tl ON tl.trademark_id = p.trademark_id  AND  tl.lang_code = '{$this->lang_code}'";



        $sql .= " WHERE ps.`id` > 0   AND ps.`value` > 0  ";
        $sql .= $searchStatusStock && $ids ? " AND p.id  not in  ({$ids})  " : " ";

        $sql .= $searchKey ? ' AND (  p.`product_code` like "%' . $searchKey . '%" || p.`product_barcode` like "%' . $searchKey . '%" || pl.`name` like "%' . $searchKey . '%" )' : '';
        $sql .= $searchDateFrom ? " AND ps.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND ps.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchStore_id ? " AND ps.`store_id` =  '{$searchStore_id}'" : "";
        $sql .= $searchServiceId ? " AND pse.`service_id` =  '{$searchServiceId}'  " : "";

        $sql .= $searchTrademark_id ? " AND p.`trademark_id` =  '{$searchTrademark_id}'" : "";

        $sql .= " group by ps.product_id ";
        $sql .= $sort ? " ORDER BY p.{$sort} {$type}" : " ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo  $sql;
        // die();
        $res = $this->mDb->getAll($sql);


        for ($i = 0; $i < count($res); $i++) {

            $res[$i]['images'] = $this->getProductimgs($res[$i]['id']);
            $res[$i]['image'] = $res[$i]['images'][0]['name'];


            $res[$i]['store_amounts_product'] = $this->productsObj->getProductStoreAmounts($res[$i]['id'], $searchStore_id);
            $res[$i]['average_purchase_price'] = $this->getAverage_purchase_price($res[$i]['id']);
            $res[$i]['last_purchase_price'] = $this->getLast_purchase_price($res[$i]['id']);

            $res[$i]['total_cost'] = floatval($res[$i]['cost']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_average_purchase_price'] = floatval($res[$i]['average_purchase_price']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_last_purchase_price'] = floatval($res[$i]['last_purchase_price']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_price_one'] = floatval($res[$i]['price_one']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_price_multi'] = floatval($res[$i]['price_multi']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_price_gomla_gomla'] = floatval($res[$i]['price_gomla_gomla']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_profit_price_one'] = floatval($res[$i]['price_one'] - $res[$i]['cost']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_profit_price_multi'] = floatval($res[$i]['price_multi'] - $res[$i]['cost']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['total_profit_price_gomla_gomla'] = floatval($res[$i]['price_gomla_gomla'] - $res[$i]['cost']) * floatval($res[$i]['store_amounts_product']);
            $res[$i]['ser_name'] = $this->productsObj->getAllServicesNameOfProductById($res[$i]['id']);
        }


        $ret['data'] = $res;


        return $ret;
    }

    public function getProductimgs($id, $aLimit = '') {
        $sql = "SELECT name ,type   FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}' and type='image' ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        return $this->mDb->getAll($sql);
    }

    public function getSearchStoresReportCount(
    $searchDateFrom, $searchDateTo, $searchKey, $searchStore_id, $searchTrademark_id, $searchServiceId, $searchStatusStock
    ) {

        $ret = array();
        $sql = "SELECT   p.*  FROM `product_stores` ps";
        $sql .= " LEFT JOIN `products` p ON p.id = ps.product_id ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id   AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `product_services` pse ON pse.product_id = ps.product_id ";

        $sql .= " WHERE ps.`id` > 0 AND ps.`value` > 0   ";

        $sql .= $searchKey ? ' AND (  p.`product_code` like "%' . $searchKey . '%" || p.`product_barcode` like "%' . $searchKey . '%" || pl.`name` like "%' . $searchKey . '%" )' : '';
        $sql .= $searchDateFrom ? " AND ps.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND ps.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchStore_id ? " AND ps.`store_id` =  '{$searchStore_id}'" : "";
        $sql .= $searchServiceId ? " AND pse.`service_id` =  '{$searchServiceId}'  " : "";

        $sql .= $searchTrademark_id ? " AND p.`trademark_id` =  '{$searchTrademark_id}'" : "";


        $sql .= " group by p.id ";
        $arr = $this->mDb->getAll($sql);
        $ret['count'] = count($arr);

        if ($searchStatusStock) {

            $notIds = '';
            for ($i = 0; $i < count($arr); $i++) {
                $store_amounts = $this->productsObj->getProductStoreAmounts($arr[$i]['id'], $searchStore_id);

                // echo $store_amounts; 
                if ($searchStatusStock == 'in_stock') {
                    if ($store_amounts <= 0 || !$store_amounts) {
                        $notIds .= '' . $arr[$i]['id'] . ',';
                        $ret['count'] -= 1;
                    }
                } else if ($searchStatusStock == 'out_of_stock') {
                    if ($store_amounts > 0) {
                        // p($res);
                        $notIds .= '' . $arr[$i]['id'] . ',';
                        $ret['count'] -= 1;
                    }
                }
            }
            // die();
            $notIds = $notIds ? substr($notIds, 0, -1) : $notIds;
            $ret['ids'] = $notIds;

            // p($res);
        }

        if (count($arr)) {

            $sum['total_store_amounts_product'] = 0;



            $sum['sum_total_cost'] = 0;
            $sum['sum_total_average_purchase_price'] = 0;
            $sum['sum_total_last_purchase_price'] = 0;

            $sum['sum_total_price_one'] = 0;
            $sum['sum_total_price_multi'] = 0;
            $sum['sum_total_price_gomla_gomla'] = 0;

            $sum['sum_total_profit_price_one'] = 0;
            $sum['sum_total_profit_price_multi'] = 0;
            $sum['sum_total_profit_price_gomla_gomla'] = 0;






            for ($i = 0; $i < count($arr); $i++) {
                $arr[$i]['store_amounts_product'] = $this->productsObj->getProductStoreAmounts($arr[$i]['id'], $searchStore_id);
                $sum['total_store_amounts_product'] += $arr[$i]['store_amounts_product'];


                $arr[$i]['average_purchase_price'] = $this->getAverage_purchase_price($arr[$i]['id']);
                $arr[$i]['last_purchase_price'] = $this->getLast_purchase_price($arr[$i]['id']);

                $arr[$i]['total_cost'] = floatval($arr[$i]['cost']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_average_purchase_price'] = floatval($arr[$i]['average_purchase_price']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_last_purchase_price'] = floatval($arr[$i]['last_purchase_price']) * floatval($arr[$i]['store_amounts_product']);

                $sum['sum_total_cost'] = $sum['sum_total_cost'] + $arr[$i]['total_cost'];
                $sum['sum_total_average_purchase_price'] = $sum['sum_total_average_purchase_price'] + $arr[$i]['total_average_purchase_price'];
                $sum['sum_total_last_purchase_price'] = $sum['sum_total_last_purchase_price'] + $arr[$i]['total_last_purchase_price'];



                $arr[$i]['total_price_one'] = floatval($arr[$i]['price_one']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_price_multi'] = floatval($arr[$i]['price_multi']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_price_gomla_gomla'] = floatval($arr[$i]['price_gomla_gomla']) * floatval($arr[$i]['store_amounts_product']);

                $sum['sum_total_price_one'] = $sum['sum_total_price_one'] + $arr[$i]['total_price_one'];
                $sum['sum_total_price_multi'] = $sum['sum_total_price_multi'] + $arr[$i]['total_price_multi'];
                $sum['sum_total_price_gomla_gomla'] = $sum['sum_total_price_gomla_gomla'] + $arr[$i]['total_price_gomla_gomla'];



                $arr[$i]['total_profit_price_one'] = floatval($arr[$i]['price_one'] - $arr[$i]['cost']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_profit_price_multi'] = floatval($arr[$i]['price_multi'] - $arr[$i]['cost']) * floatval($arr[$i]['store_amounts_product']);
                $arr[$i]['total_profit_price_gomla_gomla'] = floatval($arr[$i]['price_gomla_gomla'] - $arr[$i]['cost']) * floatval($arr[$i]['store_amounts_product']);

                $sum['sum_total_profit_price_one'] = $sum['sum_total_profit_price_one'] + $arr[$i]['total_profit_price_one'];
                $sum['sum_total_profit_price_multi'] = $sum['sum_total_profit_price_multi'] + $arr[$i]['total_profit_price_multi'];
                $sum['sum_total_profit_price_gomla_gomla'] = $sum['sum_total_profit_price_gomla_gomla'] + $arr[$i]['total_profit_price_gomla_gomla'];
            }
        }
        $ret['sum'] = $sum;
        //  echo $sql ;die();
        return $ret;
    }

    public function getAverage_purchase_price($product_id) {

        $sql = "SELECT AVG( ii.`price`) FROM `invoice_items` ii";
        $sql .= " LEFT JOIN `invoices` i ON i.id = ii.invoice_id ";
        $sql .= " WHERE i.`invoice_type` =   'receipt-invoice' and ii.product_id = '{$product_id}' group by ii.product_id  ";

        // echo $sql ;
        return $this->mDb->getOne($sql) ? $this->mDb->getOne($sql) : 0;
    }

    public function getLast_purchase_price($product_id) {

        $sql = "SELECT  ii.`price`  FROM `invoice_items` ii";
        $sql .= " LEFT JOIN `invoices` i ON i.id = ii.invoice_id ";
        $sql .= " WHERE i.`invoice_type` =   'receipt-invoice' and ii.product_id = '{$product_id}' order by ii.id desc limit 1   ";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return $res[0]['price'];
        } else {
            return 0;
        }
    }

}
