<?php

/* * *************************************************************************
 *
 *   PROJECT: rhletak
 *   powerd by ashraf hamdy
 *   Copyright 2016 IT Plus Inc
 *   http://it-plus.co/s
 *
 * ************************************************************************* */

/**
 * تحويل النص إلى صيغة صالحة للاستخدام في الروابط URL
 *
 * @param string $aParams النص المراد تحويله
 * @return string نص صالح للاستخدام في URL (بدون مسافات أو أحرف خاصة)
 */
function convert_str($aParams) {
    $aParams['string'] = strtolower($aParams['string']);
    $aParams['string'] = preg_replace('/[^a-z0-9]+/i', '-', $aParams['string']);
    $aParams['string'] = preg_replace('/\-+/', '-', $aParams['string']);
    $aParams['string'] = trim($aParams['string'], '-');

    return $aParams['string'];
}

/**
 * إنشاء المسار الصحيح للمجلد
 *
 * @param string $aPath مسار المجلد الأب
 * @param string $aTitle اسم المجلد
 * @return string المسار الكامل للمجلد بالتنسيق الصحيح
 */
function dir_form_path($aPath, $aTitle) {
    $params['string'] = $aTitle;
    $title = convert_str($params['string']);
//    $title = strtolower($title);
    return $aPath . '/' . $title;
}

function poweredBy() {

    return "<p> Powered by <a href='www.it-plus.co' target='_blank' >IT Plus </a> </p>";
}

/**
 * Prints navigation menu
 *
 * Note about url template!
 * Url template shoud contain %1 that will be replaced
 * with actual page number.  This is very convenient
 * in case url will be change (e.g. for mod_rewrite purpose
 * it changes from 'index.php?page=2' to 'index2.htm'
 */
function navigation($aTotal, $aStart, $aNum, $aUrl, $aItemsPerPage = 3, $aLinksPerPage = 5) {
    //    echo $aTotal;    echo '<br/>';
    //    echo $aStart;echo '<br/>';
    //    echo $aNum;echo '<br/>';
    //    echo $aUrl;echo '<br/>';
    //    echo $aItemsPerPage;echo '<br/>';
    //    echo $aLinksPerPage;echo '<br/>';
    //    die();
    global $Lang;
    if ($aTotal && $aTotal > $aItemsPerPage) {

        $num_pages = ceil($aTotal / $aItemsPerPage);
        //        echo $num_pages;
        //        die();
        $current_page = (int) $_GET['page'];
        $current_page = ($current_page < 1) ? 1 : ($current_page > $num_pages ? $num_pages : $current_page);

        $left_offset = ceil($aLinksPerPage / 2) - 1;
        $first = $current_page - $left_offset;
        $first = ($first < 1) ? 1 : $first;

        $last = $first + $aLinksPerPage - 1;
        $last = ($last > $num_pages) ? $num_pages : $last;

        $first = $last - $aLinksPerPage + 1;
        $first = ($first < 1) ? 1 : $first;

        $pages = range($first, $last);

        $out = '<div class="pagination pull-left" style="margin: 0;">    <ul>';

        $delim = ('.php' == strtolower(substr($aUrl, -4))) ? '?' : '&amp;';

        // Previous, First links
        if ($current_page > 1) {
            $prev = $current_page - 1;
            $out .= "<li ><a href=\"{$aUrl}{$delim}page={$prev}{$delim}items=" . (int) $_GET['items'] . "\">&raquo;</a></li>";
        } else {
            $out .= '<li class="disabled"><a href="#">&raquo;</a></li>';
        }

        foreach ($pages as $page) {
            if ($current_page == $page) {
                $out .= " <li class=\"active\"><a href=\"#\">{$page}</a></li>";
            } else {
                $out .= "<li><a href=\"{$aUrl}{$delim}page={$page}{$delim}items=" . (int) $_GET['items'] . "\"> {$page}</a> </li>";
            }
        }

        if ($current_page < $num_pages) {

            $next = $current_page + 1;
            $out .= "<li ><a href=\"{$aUrl}{$delim}page={$next}{$delim}items=" . (int) $_GET['items'] . "\">&laquo;</a></li>";
        } else {
            $out .= '<li class="disabled"><a href="#">&laquo;</a></li>';
        }

        $out .= '</div>';
    }
    $from = ($aTotal > 0) ? $aStart + 1 : $aStart;
    $to = ($aTotal > ($aStart + 1 + $aItemsPerPage)) ? $aStart + $aItemsPerPage : $aTotal;
    $out .= 'من ' . $from . ' الى ' . $to . ' الاجمالي ' . $aTotal;
    return $out;
}

/**
 * التحقق من وجود رابط تبادلي
 *
 * @param string $aRecip رابط الصفحة التبادلية
 * @return int حالة الرابط (1 إذا كان موجود وصحيح، 0 إذا كان غير موجود أو غير صحيح)
 */
function check_reciprocal($aRecip) {
    global $gDirConfig;

    $reciprocal = "<(\s*)a (.*)href=(\"{0,1}){$gDirConfig['reciprocal_text']}(\"{0,1})(.*)>(.*)</a>";

    $res = 0;
    $content = @file($aRecip);
    if ($content) {
        if ($ftext = join('', $content)) {
            $res = eregi($reciprocal, $ftext) ? 1 : 0;
        }
    }

    return $res;
}

/**
 * التحقق من الرابط وإرجاع رأس الصفحة HTTP
 *
 * @param string $aUrl رابط الصفحة المراد فحصها
 * @return int رمز حالة HTTP (مثل 200 للنجاح، 404 للصفحة غير موجودة)
 */
function get_link_header($aUrl) {
    if (preg_match("'^http://'", $aUrl)) {
        $content = @file($aUrl);
        if ($content) {
            $header = join("\n", $http_response_header);
            list(, $http_header, ) = split(" ", $header, 3);
        } else {
            $http_header = 0;
        }
    }
    return $http_header;
}

/**
 * التحقق من صحة البريد الإلكتروني
 *
 * @param string $aEmail البريد الإلكتروني المراد التحقق منه
 * @return bool صحيح إذا كان البريد صالح، خطأ إذا كان غير صالح
 * 
 * يتحقق من صحة البريد الإلكتروني عن طريق استخدام تعبير منتظم يتحقق من وجود الأحرف والرقام والأحرف الخاصة في البريد الإلكتروني.
 * 
 * @example
 * valid_email("example@example.com"); // true
 * valid_email("example"); // false
 */
function valid_email($aEmail) {
    return preg_match('/^[a-z0-9\-_\.]+@[a-z0-9\-_]+(\.[a-z0-9]{2,4})+$/i', $aEmail);
}

/**
 * تحويل وصف الرابط إلى HTML
 *
 * @param array $aParams مصفوفة المعاملات التي تحتوي على النص المراد تحويله
 * @return string النص بعد تحويله إلى تنسيق HTML
 * 
 * تقوم الدالة بتحويل النص العادي إلى HTML مع معالجة:
 * - الروابط التشعبية
 * - علامات السطر الجديد
 * - الأحرف الخاصة
 */
function text_to_html($aParams) {
    $out = '';

    $aParams['aText'] = htmlentities($aParams['aText']);

    $aParams['aText'] = preg_replace('/\[b\]/', '<b>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/b\]/', '</b>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[i\]/', '<i>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/i\]/', '</i>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[u\]/', '<u>', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/u\]/', '</u>', $aParams['aText']);

    $aParams['aText'] = preg_replace('/\[hl\]/', '<span class="highlight">', $aParams['aText']);
    $aParams['aText'] = preg_replace('/\[\/hl\]/', '</span>', $aParams['aText']);

    $aParams['aText'] = nl2br($aParams['aText']);
    if ($aParams['aParagraph']) {
        $paragraphs = explode("\r\n", $aParams['aText']);
        foreach ($paragraphs as $paragraph) {
            if (strlen($paragraph) > 0) {
                $out .= "<p class=\"user\">{$paragraph}</p>\n";
            }
        }
    } else {
        $out = $aParams['aText'];
    }
    return $out;
}

function format($aParam) {
    return number_format($aParam, 3);
}

function newPassword() {
    $pass = rand(100000, 1000000);

    return $pass;
}

function generateKey() {
    $key = rand(10000, 100000);
    return $key;
}

function generateBarCodeKey() {
    $code = rand(100000000000, 999999999999);
    return $code;
}

function rename_file($file_name) {
    $date = date("YmdHms");
    $rand = rand(10000, 99999);
    $encr = md5($date . $rand);
    $mbss = mb_substr($encr, "4", "4", "utf-8");
    $new_name = $date . "_" . $mbss;
    return $new_name;
}

function print_box($aContent = '') {
    if ($aContent) {
        foreach ($aContent as $key => $value) {
            for ($i = 0; $i < count($value); $i++) {
                $cont .= " <div class='alert alert-{$key}'>
                          <button class='close' data-dismiss='alert' type='button'>×</button>
                          {$value[$i]}
                      </div>";
            }
        }
        return $cont;
    }
}

/**
 * إنشاء عنصر قائمة متعدد المستويات مع محتوى فرعي
 *
 * @param string $aId معرف العنصر (يستخدم للمقارنة مع MENU_PARENT)
 * @param string $aTitle عنوان العنصر
 * @param string $aContent المحتوى الفرعي للعنصر
 * @param string $aIcon الأيقونة المستخدمة (HTML)
 * @return string عنصر HTML للقائمة
 */
function print_box2($aId = '', $aTitle = '', $aContent = '', $aIcon = '') {
    // تحديد حالة العنصر (نشط أم لا)
    $isActive = (MENU_PARENT == $aId);

    // تحديد الصفوف CSS
    $liClass = $isActive ? 'start active' : '';
    $subMenuStyle = $isActive ? 'block' : 'none';

    // إذا لم يتم تحديد أيقونة، استخدم الأيقونة الافتراضية
    $icon = $aIcon ?: '<i class="icon-puzzle"></i>';

    // بناء HTML
    $html = sprintf('
        <li class="%s">
            <a href="javascript:;">
                %s
                <span class="title">%s</span>
                <span class="arrow open"></span>
            </a>
            <ul class="sub-menu" style="display: %s;">
                %s
            </ul>
        </li>',
            $liClass,
            $icon,
            htmlspecialchars($aTitle),
            $subMenuStyle,
            $aContent
    );

    return $html;
}

/**
 * تحويل قيم المصفوفة إلى نص واحد
 *
 * @param array $arr المصفوفة المراد تحويلها
 * @return string نص يحتوي على قيم المصفوفة
 */
function fetchArrayValue($arr) {
    $str = "";
    foreach ($arr as $value) {
        $str .= $value;
        if (next($arr) == true)
            $str .= ",";
    }
    return $str;
}

/**
 * تحويل قيم عمود معين من مصفوفة إلى نص مع فصل القيم بفواصل
 *
 * @param array $arr المصفوفة المدخلة
 * @param string $column اسم العمود المطلوب استخراج قيمه
 * @return string نص يحتوي على القيم مفصولة بفواصل، مع إزالة القيم المكررة
 */
function fetchArrayValue_from_dataBase($arr, $column) {
    if (empty($arr)) {
        return '';
    }

    // استخدام array_column للحصول على القيم مباشرة
    $values = array_column($arr, $column);

    // إزالة القيم المكررة
    $unique_values = array_unique($values);

    // تحويل المصفوفة إلى نص
    return implode(',', $unique_values);
}

function time_ago($ptime) {
    $etime = time() - $ptime;

    if ($etime < 1) {
        return '0 seconds';
    }

    $a = array(
        12 * 30 * 24 * 60 * 60 => 'year',
        30 * 24 * 60 * 60 => 'month',
        24 * 60 * 60 => 'day',
        60 * 60 => 'hour',
        60 => 'minute',
        1 => 'second'
    );

    foreach ($a as $secs => $str) {
        $d = $etime / $secs;
        if ($d >= 1) {
            $r = round($d);
            return $r . ' ' . $str . ($r > 1 ? 's' : '') . ' ago';
        }
    }
}

/**
 * طباعة عناصر القائمة بتنسيق محدد
 *
 * @param array $aMenu مصفوفة تحتوي على عناصر القائمة
 * @return string النص المنسق للقائمة
 */
function print_menu($aMenu) {

//    echo "<pre>";
//    print_r($aMenu);
//    echo "</pre>";
    foreach ($aMenu as $key => $value) {
        $caption = $value['caption'];
        $url = $value['url'];
        $icon = $value['icon'] ? "<i class=\"{$value['icon']}\"></i>" : '';

        if (THIS_PAGE == $key) {
            $out .= '<li class="active">
<a href=' . $url . '>
    ' . $icon . '
' . $caption . '
</a>
</li>';
        } else {
            $out .= '<li class="">
<a href=' . $url . '>
' . $icon . '
' . $caption . '
</a>
</li>';
        }
    }


    return $out;
}

function in_array_r($needle, $haystack, $strict = false) {
    foreach ($haystack as $item) {
        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && in_array_r($needle, $item, $strict))) {
            return true;
        }
    }

    return false;
}

function p($value, $die = true) {
    echo "<pre>";
    print_r($value);
    if ($die == true) {
        die('End Here');
    }
}

function Export_Database($host, $user, $pass, $name, $tables, $backup_name = false) {

//    $mysqli = new mysqli($host, $user, $pass, $name);
//    $mysqli->select_db($name);
//    $mysqli->query("SET NAMES 'utf8'");
//    $queryTables = $mysqli->query('SHOW TABLES');
//    while ($row = $queryTables->fetch_row()) {
//        $target_tables[] = $row[0];
//    }
//    if ($tables !== false) {
//        $target_tables = array_intersect($target_tables, $tables);
//    }
//    $content = '';
//    $const_All = '';
//    foreach ($target_tables as $table) {
//        $result = $mysqli->query('SELECT * FROM ' . $table);
//        $fields_amount = $result->field_count;
//        $rows_num = $mysqli->affected_rows;
//        $res = $mysqli->query('SHOW CREATE TABLE ' . $table);
//        $TableMLine = $res->fetch_row();
//
//        $index_of_PRIMARY = strpos($TableMLine[1], 'PRIMARY');
//        $index_of_UNIQUE = strpos($TableMLine[1], 'UNIQUE');
//
//        if ($index_of_PRIMARY > -1) {
//            $index_of_CONSTRAINT = strpos($TableMLine[1], 'PRIMARY');
//            // $replay_by = ",\n\n PRIMARY KEY (`id`)";
//        } else if ($index_of_UNIQUE > -1) {
//            $index_of_CONSTRAINT = strpos($TableMLine[1], 'UNIQUE');
//            $replay_by = '';
//        } else {
//            $index_of_CONSTRAINT = strpos($TableMLine[1], 'KEY');
//            $replay_by = '';
//        }
//
//        if ($index_of_CONSTRAINT > -1) {
//            $index_of_last = strrpos($TableMLine[1], ')');
//
//            $contrints_of_table = substr($TableMLine[1], $index_of_CONSTRAINT, $index_of_last - $index_of_CONSTRAINT);
//            $contrints_of_table = str_replace("PRIMARY KEY (`id`)", '', $contrints_of_table);
//
//            $const_All .= trim($contrints_of_table) ? ' ALTER TABLE ' . $table . ' ADD ' . str_replace(",", ",ADD", $contrints_of_table) . ";" : '';
//            $const_All = str_replace("ADD ,ADD", "ADD", $const_All);
//
//
//            $TableMLine[1] = str_replace($contrints_of_table, "", $TableMLine[1]);
//            // $TableMLine[1]  = substr_replace($TableMLine[1], $replay_by, strrpos($TableMLine[1],  ','), 1);
//        }
//        if (!($index_of_PRIMARY > -1)) {
//            $TableMLine[1] = substr_replace($TableMLine[1], $replay_by, strrpos($TableMLine[1], ','), 1);
//        }
//
//
//
//        $content = (!isset($content) ? '' : $content) . "\n\n" . $TableMLine[1] . ";\n\n";
//
//        for ($i = 0, $st_counter = 0; $i < $fields_amount; $i++, $st_counter = 0) {
//            while ($row = $result->fetch_row()) { //when started (and every after 100 command cycle):
//                if ($st_counter % 100 == 0 || $st_counter == 0) {
//                    $content .= "\nINSERT INTO " . $table . " VALUES";
//                }
//                $content .= "\n(";
//                for ($j = 0; $j < $fields_amount; $j++) {
//                    $row[$j] = str_replace("\n", "\\n", addslashes($row[$j]));
//                    if (isset($row[$j])) {
//                        $content .= "'" . $row[$j] . "'";
//                    } else {
//                        $content .= '';
//                    }
//                    if ($j < ($fields_amount - 1)) {
//                        $content .= ',';
//                    }
//                }
//                $content .= ")";
//                //every after 100 command cycle [or at last line] ....p.s. but should be inserted 1 cycle eariler
//                if ((($st_counter + 1) % 100 == 0 && $st_counter != 0) || $st_counter + 1 == $rows_num) {
//                    $content .= ";";
//                } else {
//                    $content .= ",";
//                }
//                $st_counter = $st_counter + 1;
//            }
//        }
//        $content .= "\n\n\n";
//    }
//    $ret = [];
//
//    //$backup_name = $backup_name ? $backup_name : $name."___(".date('H-i-s')."_".date('d-m-Y').")__rand".rand(1,11111111).".sql";
//    $name = $backup_name ? $backup_name : $name . ".sql";
//
//    $ret['db_name'] = date('Y-m-d H.i.s') . '-' . $name;
//    $ret['content'] = $content . $const_All;
//    return $ret;
}

function restoreDB($host, $user, $pass, $name, $sql) {
    $mysqli = new mysqli($host, $user, $pass, $name);
    $mysqli->select_db($name);
    $mysqli->query("SET NAMES 'utf8'");
    $mysqli->query("SET FOREIGN_KEY_CHECKS = 0;");
    $queryTables = $mysqli->query('SHOW TABLES');
    while ($row = $queryTables->fetch_row()) {
        $mysqli->query('DROP TABLE IF EXISTS ' . $row[0]);
    }
    $data = str_replace("''", "NULL", $sql);

    $handel = new PDO('mysql:host=' . $host . ';dbname=' . $name, $user, $pass);
    $handel->query("set names 'utf8mb4';");

    $array_query = explode(";", $data);

    for ($i = 0; $i < count($array_query); $i++) {
        $query = $handel->prepare($sql);
        $query->execute();
    }




//    p($sql);
//    p($array_query);
    return true;
}

function sendPostData($url, $data) {

    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

    $headers = array(
        "Content-Type: multipart/form-data",
    );
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

    //for debug only!
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

    $resp = curl_exec($curl);
    curl_close($curl);
    // p($resp);
    // Further processing ...
}

function remoHTMLCodeWithSupLimit($data_, $limit) {
    $data_ = strip_tags(str_replace(array("&nbsp;", "&nbsp;"), " ", "" . $data_));
    ;
    $data_ = trim($data_);
    // if (strlen($data_) > $limit) {
    //     $array   = str_split($data_,$limit -3);
    //     $data_ = $array[0]. '...';
    //     // $data_ = substr(" " . $data_, 0, 150) . '...';
    // }
    return ($data_);
}

function frist_trim_text($input_1, $length, $strip_html = true) {

    //strip tags, if desired
    if ($strip_html) {
        $input_1 = strip_tags($input_1);
    }
    //no need to trim, already shorter than trim length
    if (mb_strlen($input_1, 'UTF-8') <= $length || !$length) {
        $input_1 = str_replace(array("&nbsp;"), " ", $input_1);
        return $input_1;
    }
    $last_space = mb_strrpos(mb_substr($input_1, 0, $length, "utf-8"), ' ', "utf-8");
    //    echo $last_space . "<hr>";
    $trimmed_text = mb_substr($input_1, 0, $last_space, "utf-8");

    $trimmed_text = str_replace(array("&nbsp;"), " ", $trimmed_text);

    return $trimmed_text . ' ...';
}

function get_string_between($string, $start, $end) {
    $string = ' ' . $string;
    $ini = strpos($string, $start);
    if ($ini == 0)
        return '';
    $ini += strlen($start);
    $len = strpos($string, $end, $ini) - $ini;
    return substr($string, $ini, $len);
}

function GetExt($filename) {

    // if file name is not null
    if (!is_null($filename)) {

        // make the file name lower case and crop the ext
        $fileext = strtolower(strrchr(strtolower($filename), '.'));
        // replace the dot (.) with blank
        $fileext = str_replace(".", "", $fileext);
        // return the file ext
        // if($fileext=="webp"){
        //     return("jpg");
        // }
        return ($fileext);
    } else {
        // return false if file name is null
        return (FALSE);
    }
}

function httpGet($url) {

    //Initialize cURL.
    $ch = curl_init();

    //Set the URL that you want to GET by using the CURLOPT_URL option.
    curl_setopt($ch, CURLOPT_URL, $url);

    //Set CURLOPT_RETURNTRANSFER so that the content is returned as a variable.
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    //Set CURLOPT_FOLLOWLOCATION to true to follow redirects.
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);

    //Execute the request.
    $data = curl_exec($ch);

    //Close the cURL handle.
    curl_close($ch);

    //Print the data out onto the page.
    return $data;
}

function getDeviceData() {
    $data = array();
    $data['ip'] = get_ip_address();
    $data['device_type'] = get_device_type();
    $browser_info = get_browser_info();
    $data['browser'] = $browser_info['name'];
    $data['country'] = getCountry();
    return $data;
}

function getCountry() {
    $ip = $_SERVER['REMOTE_ADDR'];
    $ip_data = @json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=" . $ip));
    if (!empty($ip_data) && $ip_data->geoplugin_countryName != null) {
        return $ip_data->geoplugin_countryName;
    }
    return null;
}

//function getBrowser() {
//    $user_agent = $_SERVER['HTTP_USER_AGENT'];
//    $browser = 'unknown';
//    $browser_array = array(
//        'MSIE' => 'Internet Explorer',
//        'Trident' => 'Internet Explorer',
//        'Edge' => 'Edge',
//        'Firefox' => 'Firefox',
//        'Chrome' => 'Chrome',
//        'Safari' => 'Safari',
//        'Opera' => 'Opera',
//    );
//    foreach ($browser_array as $browser_name => $full_name) {
//        if (stripos($user_agent, $browser_name) !== false) {
//            $browser = $full_name;
//            break;
//        }
//    }
//    return $browser;
//}
//
//function getDeviceType() {
//    $user_agent = $_SERVER['HTTP_USER_AGENT'];
//    $device_types = array(
//        "computer" => array("Windows", "Mac", "Linux"),
//        "tablet" => array("iPad", "Android", "Tablet"),
//        "mobile" => array("iPhone", "Android", "Mobile")
//    );
//    foreach ($device_types as $device_type => $devices) {
//        foreach ($devices as $device) {
//            if (strpos($user_agent, $device) !== false) {
//                return $device_type;
//            }
//        }
//    }
//    return "unknown";
//}
/////////////////////////
// Get device type
function get_device_type() {
    $user_agent = $_SERVER['HTTP_USER_AGENT'];
//    echo $user_agent;
    if (strpos($user_agent, 'Mobile') !== false) {
        // The user is using a mobile device
        return 'mobile';
    } elseif (strpos($user_agent, 'Tablet') !== false) {
        // The user is using a tablet device
        return 'tablet';
    } else {
        // The user is using a desktop device
        return 'computer';
    }
}

// Get device type
//function get_device_type() {
//    $tablet_browser = 0;
//    $mobile_browser = 0;
//    $body_class = 'computer';
//    $user_agent = $_SERVER['HTTP_USER_AGENT'];
//
//    if (preg_match('/(tablet|ipad|playbook)|(android(?!.*mobile))/i', $user_agent)) {
//        $tablet_browser++;
//        $body_class = "tablet";
//    }
//
//    if (preg_match('/Mobile|iP(hone|od)|Android|BlackBerry|IEMobile|Kindle|NetFront|Silk-Accelerated|(hpw|web)OS|Fennec|Minimo|Opera M(obi|ini)|Blazer|Dolfin|UCBrowser|Mobile Safari|Mobile Firefox|Mozilla\/5.0/i', $user_agent)) {
//        $mobile_browser++;
//        $body_class = "mobile";
//    }
//
//    if ($tablet_browser > 0) {
//        return 'tablet';
//    } elseif ($mobile_browser > 0) {
//        return 'mobile';
//    } else {
//        return 'computer';
//    }
//}
// Get IP address
function get_ip_address() {
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
        $ip = $_SERVER['REMOTE_ADDR'];
    }
    return $ip;
}

// Get browser name and version
function get_browser_info() {
    $user_agent = $_SERVER['HTTP_USER_AGENT'];
    $browser_name = 'Unknown';
    $browser_version = '';

    if (preg_match('/MSIE/i', $user_agent) && !preg_match('/Opera/i', $user_agent)) {
        $browser_name = 'Internet Explorer';
        $browser_agent = 'MSIE';
    } elseif (preg_match('/Firefox/i', $user_agent)) {
        $browser_name = 'Mozilla Firefox';
        $browser_agent = 'Firefox';
    } elseif (preg_match('/Chrome/i', $user_agent)) {
        $browser_name = 'Google Chrome';
        $browser_agent = 'Chrome';
    } elseif (preg_match('/Safari/i', $user_agent)) {
        $browser_name = 'Apple Safari';
        $browser_agent = 'Safari';
    } elseif (preg_match('/Opera/i', $user_agent)) {
        $browser_name = 'Opera';
        $browser_agent = 'Opera';
    } elseif (preg_match('/Netscape/i', $user_agent)) {
        $browser_name = 'Netscape';
        $browser_agent = 'Netscape';
    }

    $browser_version = '';
    $pattern = '/(?<browser>' . $browser_agent . ')[\/|\s](?<version>[0-9]+(?:\.[0-9]+)*)/';
    if (preg_match($pattern, $user_agent, $match)) {
        $browser_version = $match['version'];
    }

    return array('name' => $browser_name, 'version' => $browser_version);
}

//
/////////////////////
function search_active($v, $mode = '') {
    // التحقق من صحة الإدخال
    if (!isset($v) || !is_string($v)) {
        return " = '1' "; 
    }

    // معالجة حالة المسؤول
    if ($mode === 'admin') {
        return $v === '2' ? " = '2' " : " LIKE '%,{$v},%'"; 
    }

    // التحقق من وجود AFFILIATOR['id']
    if (!defined('AFFILIATOR') || !isset(AFFILIATOR['id'])) {
        return " = '1' -- AFFILIATOR غير معرف";
    }

    $aff_id = AFFILIATOR['id'];
    $word = "{$aff_id}_{$v}";

    // معالجة الحالات الخاصة باستخدام if-else
    if ($v === '!=0') {
        return " NOT LIKE '%,{$aff_id}_0,%' ";
    } elseif ($v === '!=2') {
        return " != '2' ";
    } elseif ($v === '2') {
        return " = '2' ";
    } 
    
    // الحالة الافتراضية
    return " LIKE '%,{$word},%' ";
}


//function activeFormat($active) {
//    if ($active == 2) {
//        return $active;
//    } else {
//        $pattern = "/," . preg_quote(AFFILIATOR['id'], '/') . "_(\\d),/";
//        if (preg_match($pattern, $active, $matches)) {
//            return $matches[1];
//        }
//    }
//    return '0';
//}

function activeFormat($active) {
    // Return directly if $active equals 2
    if ($active === '2') {
        return (string) $active;
    }

    // Ensure AFFILIATOR is properly defined to avoid issues in PHP 8.1
    $affiliatorId = defined('AFFILIATOR') && isset(AFFILIATOR['id']) ? AFFILIATOR['id'] : '';

    // Use a secure pattern with the AFFILIATOR ID
    $pattern = sprintf('/,%s_(\d),/', preg_quote($affiliatorId, '/'));

    // Perform the regex match
    return preg_match($pattern, $active, $matches) ? (string) $matches[1] : '0';
}

//function search_word_in_column($column, $word) {
////    $query = "$column LIKE '$word %' OR $column LIKE '% $word %' OR $column LIKE '%$word'";
//    $query = "$column LIKE '%$word%'";
//    return $query;
//}

function search_word_in_column($column, $word, $type = '') {
//    echo "<pre>";
//    print_r($column);
//    echo "</pre>";
    if ($type == 'search_word') {
        $sql = ' ';
        $pattern = implode("|", array_map('trim', explode(",", $word)));
        $exactMatches = [];
        $likeConditions = [];
        $terms = explode(",", $word);

        foreach ($terms as $term) {
            $trimmedTerm = trim($term);
            if (preg_match('/^".*"$/', $trimmedTerm)) {
                $exactMatches[] = trim($trimmedTerm, '"');
            } else {
                $likeConditions[] = $trimmedTerm;
            }
        }

        $searchConditions = [];
        if (!empty($exactMatches)) {
            foreach ($exactMatches as $match) {
                foreach ($column as $col_name) {
                    $searchConditions[] = $col_name . ' LIKE "% ' . $match . '%"';
                    $searchConditions[] = $col_name . ' LIKE "% ' . $match . ' %"';
                    $searchConditions[] = $col_name . ' LIKE "' . $match . ' %"';
                    $searchConditions[] = $col_name . ' LIKE "' . $match . '"';
                }
            }
        }

        if (!empty($likeConditions)) {
            $pattern = implode("|", $likeConditions);
            foreach ($column as $col_name) {
                $searchConditions[] = $col_name . ' REGEXP "' . $pattern . '"';
            }
        }

        if (!empty($searchConditions)) {
            $sql .= ' AND (' . implode(' OR ', $searchConditions) . ')';
        }
        return $sql;
    } else {
        $query = "$column LIKE '%$word%'";
        return $query;
    }
}

function copyFolderUploads($user_name) {
    global $cpanelUrl;
    global $cpaneluser;
    global $cpanelPwd;
    global $cpanelPort;

    $basePath = __DIR__;
    $lastItem = basename($basePath);
    $sourceFolder = str_replace("/$lastItem", '', $basePath);

    $data = [
        'cpanel_jsonapi_user' => $cpaneluser,
        'cpanel_jsonapi_apiversion' => '2', // Use API version 2
        'cpanel_jsonapi_module' => 'Fileman',
        'cpanel_jsonapi_func' => 'fileop',
        'op' => 'copy',
        'sourcefiles' => $sourceFolder . '/uploads-temp/*',
        'destfiles' => $sourceFolder . '/uploads/' . $user_name,
    ];

    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, "https://$cpanelUrl:$cpanelPort/json-api/cpanel");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($curl, CURLOPT_HTTPHEADER, [
        'Authorization: Basic ' . base64_encode("$cpaneluser:$cpanelPwd"),
    ]);
    $response = curl_exec($curl);
    curl_close($curl);

    return $response;
}

function deleteFolder($user_name) {
    global $cpanelUrl;
    global $cpaneluser;
    global $cpanelPwd;
    global $cpanelPort;

    $basePath = __DIR__;
    $lastItem = basename($basePath);
    $sourceFolder = str_replace("/$lastItem", '', $basePath);

    $folderToDelete = $sourceFolder . '/uploads/' . $user_name . '/';

    $data = [
        'cpanel_jsonapi_user' => $cpaneluser,
        'cpanel_jsonapi_apiversion' => '2', // Use API version 2
        'cpanel_jsonapi_module' => 'Fileman',
        'cpanel_jsonapi_func' => 'fileop',
        'op' => 'unlink', // Use 'unlink' operation to delete the folder
        'sourcefiles' => $folderToDelete,
    ];

    $curl = curl_init();

// Set cURL options
    curl_setopt($curl, CURLOPT_URL, "https://$cpanelUrl:$cpanelPort/json-api/cpanel");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($curl, CURLOPT_HTTPHEADER, [
        'Authorization: Basic ' . base64_encode("$cpaneluser:$cpanelPwd"),
    ]);

// Execute cURL request
    $response = curl_exec($curl);

//// Check for cURL errors
//if (curl_errno($curl)) {
//    echo 'cURL Error: ' . curl_error($curl);
//} else {
//    // Decode the API response
//    echo $response."<hr>";
//    $apiResponse = json_decode($response, true);
//    if ($apiResponse['cpanelresult']['data']['result'] === 1) {
//        echo 'Folder deleted successfully!';
//    } else {
//        echo 'Error deleting folder: ' . $apiResponse['cpanelresult']['data']['reason'];
//    }
//}
// Close cURL session
    curl_close($curl);
    return $response;
}

function processTitle($title) {
    // استبدال القيم المطلوبة بالشرطة "-"
    $processed_title = str_replace(array(" ", ")", "(", ",", "/", "%", "+", "&"), "-", $title);

    // إزالة الأحرف الزائدة من البداية والنهاية باستخدام trim
    $processed_title = trim($processed_title, "-");

    // تحليل الشرطات المتتالية وإعادة النتيجة
    $processed_title = preg_replace("/-+/", "-", $processed_title);

    // إعادة النتيجة
    return $processed_title;
}

function replaceTitle($title) {
    // استبدال القيم المطلوبة بالشرطة "-"
    $replace_title = str_replace(array("`", ")", "(", ",", "/", "%", "+", "&"), " ", $title);

    // إزالة الأحرف الزائدة من البداية والنهاية باستخدام trim
    $replace_title = trim($replace_title, " ");

    // تحليل الشرطات المتتالية وإعادة النتيجة
    $replace_title = preg_replace("/-+/", " ", $replace_title);

    // إعادة النتيجة
    return $replace_title;
}

function echoSql($stmt) {
    $stmt->debugDumpParams();
}

function getPlaceHolders($ids) {
    $ids = trim($ids, '()');
    $idsArray = explode(',', $ids);
    $placeholders = implode(',', array_map(function ($key) {
                return ":id" . $key;
            }, array_keys($idsArray)));
    return [
        "ids" => $idsArray,
        "placeholders" => $placeholders
    ];
}
