<?php

$couponsObj = new coupons();

class coupons {

    private $mDb;
    private $mConfig;
    private $dateTime;
    private $lang_code;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getCoupons($mode, $aStart, $aLimit, $searchCode, $sort, $type) {
        $clientId = CLIENT['id'] ? CLIENT['id'] : DEVICEID;
        $now = date('Y-m-d');

        $sql = "SELECT c.id,c.code ,cl.title ,cl.description,c.marketing_coupon FROM coupons c ";
        $sql .= " LEFT JOIN `coupon_langs` cl ON c.id = cl.coupon_id AND cl.lang_code ='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `coupons_used` cu ON c.id = cu.coupon_id  AND cu.client_id ='{$clientId}' ";
        $sql .= " WHERE   c.active  = '1' and c.coupon_status ='valid'  AND c.`affiliator_id` = '" . AFFILIATOR['id'] . "' ";

        $sql .= CLIENT['id'] ? " and (( c.client_type  = 'specific_clients' AND c.`client_type_id` like '%," . CLIENT['id'] . ",%' ) " : "";
        $sql .= CLIENT['id'] ? " || (c.client_type  = 'group' AND c.`client_type_id` like '%," . CLIENT['group_id'] . ",%' ) " : "";
        $sql .= CLIENT['id'] ? " || ( c.client_type  = 'all' AND c.marketing_coupon='0' ) ||  (c.`marketer_client_id`=" . CLIENT['id'] . ") )" : "";

        $sql .= !CLIENT['id'] ? " and ( c.client_type  = 'visitors') " : "";

        $sql .= " AND (c.`coupon_start_date` <= '{$now}' ||  c.`coupon_start_date` is Null     )  ";
        $sql .= " AND (c.`coupon_end_date` >= '{$now}'  ||  c.`coupon_end_date` is Null     )";
        $sql .= " AND ( c.`show_on`  = '" . SETFROM . "'  ||  c.`show_on`  = 'both') ";
        $sql .= $searchCode ? " AND c.code  ='{$searchCode}' " : '';
        $sql .= " Group by c.id ";
        $sql .= " ORDER BY c.{$sort},c.date_added {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['description'] = nl2br($res[$i]['description']);
        }
        return $res;
    }

    function getCountCouponsAvailable($mode) {

        $now = date('Y-m-d');

        $sql = "SELECT count(c.id)FROM coupons c ";
        $sql .= " LEFT JOIN `coupon_langs` cl ON c.id = cl.coupon_id AND cl.lang_code ='{$this->lang_code}' ";
        $sql .= " LEFT JOIN `coupons_used` cu ON c.id = cu.coupon_id  AND cu.client_id ='" . CLIENT['id'] . "' ";
        $sql .= " WHERE   c.active  = '1' and c.coupon_status ='valid'  AND c.`affiliator_id` = '" . AFFILIATOR['id'] . "' ";

        $sql .= " and (( c.client_type  = 'specific_clients' AND c.`client_type_id` like '%," . CLIENT['id'] . ",%' ) ";
        $sql .= " || (c.client_type  = 'group' AND c.`client_type_id` like '%," . CLIENT['group_id'] . ",%' ) ";
        $sql .= " || ( c.client_type  = 'all' AND c.marketing_coupon='0' ) ||  (c.`marketer_client_id`=" . CLIENT['id'] . ") )";
        $sql .= " AND (c.`coupon_start_date` <= '{$now}' ||  c.`coupon_start_date` is Null     )  ";
        $sql .= " AND (c.`coupon_end_date` >= '{$now}'  ||  c.`coupon_end_date` is Null     )";
        $sql .= " AND ( c.`show_on`  = '" . SETFROM . "'  ||  c.`show_on`  = 'both') ";
        $sql .= " Group by c.id ";

//        echo $sql."<hr>";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

    function getCouponsUsed($aStart, $aLimit, $sort, $type) {

        $now = date('Y-m-d');

        $sql = "SELECT c.id,c.code ,cl.title ,cl.description FROM coupons_used cu ";
        $sql .= " LEFT JOIN `coupons` c ON  cu.coupon_id = c.id  ";
        $sql .= " LEFT JOIN `coupon_langs` cl ON c.id = cl.coupon_id AND cl.lang_code ='{$this->lang_code}' ";
        $sql .= " WHERE  cu.client_id ='" . CLIENT['id'] . "'  AND cu.`affiliator_id` = '" . AFFILIATOR['id'] . "' ";

        $sql .= " Group by c.id ";
        $sql .= " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['description'] = nl2br($res[$i]['description']);
        }
        return $res;
    }

    public function addUseCoupon($data) {
        $sql = "SELECT * FROM `coupons` ";
        $sql .= " WHERE code = '{$data['code']}' and active='1' ";
//        echo $sql."<hr>";
        return $this->mDb->getRow($sql);
    }

    public function getCouponActive($id) {
        $sql = "SELECT active FROM `coupons` ";
        $sql .= " WHERE id = '{$id}' ";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function getCouponsUsedCount($data) {
        $sql = "SELECT count(id) FROM `coupons_used` ";
        $sql .= " WHERE code = '{$data['code']}' and coupon_id = '{$data['id']}' ";
        return $this->mDb->getOne($sql);
    }

    public function getCouponsUsedCountCustomer($data) {
        $sql = "SELECT count(id) FROM `coupons_used` ";
        $sql .= " WHERE code = '{$data['code']}' and coupon_id = '{$data['id']}' ";
        $sql .= "   AND  `client_id` = '" . CLIENT['id'] . "' ";

        return $this->mDb->getOne($sql);
    }

    public function getUsedMarketingCouponInCustomer($data) {
        $sql = "SELECT cu.id FROM `coupons_used` cu ";
        $sql .= " LEFT JOIN `coupons` c ON  cu.coupon_id = c.id  ";
        $sql .= " WHERE c.marketing_coupon = '1'  ";
        $sql .= "   AND  cu.`client_id` = '" . CLIENT['id'] . "' ";
//        echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    public function addCouponUsed($data, $Req) {
        $clientId = CLIENT['id'] ? CLIENT['id'] : DEVICEID;
        $sql = "INSERT INTO `coupons_used` SET ";
        $sql .= " `coupon_id` = '{$data['id']}',`code`='{$data['code']}' ";
        $sql .= ",`affiliator_id`='" . AFFILIATOR['id'] . "',`client_id`='{$clientId}' ";
        $sql .= ",`mode`='{$Req['mode']}',`mode_id`='{$Req['mode_id']}' ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
//        echo $sql."<hr>";
        return $this->mDb->queryreturnlastid($sql);
    }

    public function getCouponUsedInId($id) {
        $sql = "SELECT * FROM `coupons_used` ";
        $sql .= " WHERE id = '{$id}' ";
        return $this->mDb->getRow($sql);
    }

    public function updateCouponUsed($mode_id, $Req) {
        $sql = " UPDATE `coupons_used` SET `mode` = 'invoice' , `mode_id` = '{$mode_id}'";
        $sql .= " WHERE   `mode` = 'cart' AND `mode_id` = '{$Req['cart_id']}' ";

        $sql .= $balance['user_id'] ? "AND `user_id` = '{$balance['user_id']}' " : ' ';
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function deleteUseCoupon($id) {
        $clientId = CLIENT['id'] ? CLIENT['id'] : DEVICEID;
        $sql = "DELETE FROM  `coupons_used` ";
        $sql .= "WHERE id='{$id}' and`affiliator_id`='" . AFFILIATOR['id'] . "' and client_id = '{$clientId}' ";
//           echo $sql."<hr>";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function getCouponUsedInfo($mode_id, $mode) {
        $sql = "SELECT 
                    cu.*,
                    c.marketing_coupon,
                    c.marketer_client_id,
                    c.marketer_commission_type,
                    c.marketer_commission 
                FROM coupons_used cu
                LEFT JOIN coupons c ON cu.coupon_id =c.id
                WHERE cu.mode_id = :mode_id and cu.mode = :mode ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute([':mode_id' => $mode_id, ':mode' => $mode]);
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res ? $res : '';
    }

    function getServiceTitleByID($id) {
        $sql = "SELECT sl.ser_name FROM service_langs sl ";
        $sql .= " WHERE sl.service_id  = '{$id}'  ";
        return $this->mDb->getOne($sql);
    }

    function getTreadMarketTitleByID($id) {

        $sql = "SELECT tl.title FROM trademark_langs tl ";
        $sql .= " WHERE tl.trademark_id  = '{$id}'  ";

        return $this->mDb->getOne($sql);
    }

    // echo LANGUAGE ;die();
    //   echo $sql; die();
    function getOfferNormal($id) {
        $sql = "SELECT * FROM `offer_normal`";
        $sql .= " WHERE `offer_id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        // p($res,false);
        $res['offer_on_id'] = substr($res['offer_on_id'], 1);
        $res['offer_on_id'] = substr($res['offer_on_id'], 0, -1);
        // p($res);

        return $res;
    }

    function getAlloffer_showing_type_options() {

        $sql = "SELECT * FROM offer_showing_type_options  ";
        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function getOneOffer($id, $trim_attachment_single) {



        $sql = "SELECT  b.offer_type , ol.title , ol.description , ol.attachment_single FROM `offers` b";
        $sql .= " LEFT JOIN `offer_langs` ol ON b.id = ol.offer_id  AND ol.lang_code ='{$this->lang_code}' ";
        $sql .= " WHERE b.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {

            if ($trim_attachment_single == 'trim_attachment_single') {
                $res['attachment_single'] = frist_trim_text($res['attachment_single'], 70, false);
                // $res['description'] = 	frist_trim_text($res['description'], 0, true);
            }
        }
        return $res;
    }

    function getOneOfferFull($id) {


        $sql = "SELECT b.* , u2.user_name AS 'affiliator_name'  FROM `offers` b";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = b.affiliator_id ";
        $sql .= " WHERE b.`id` = '{$id}' ";
        //echo $sql ;
        $res = $this->mDb->getRow($sql);
        if ($res) {
            if ($this->lang_code == 'ar') {
                $res['image'] = $res['image'];
            } else if ($this->lang_code == 'en') {
                $res['image'] = $res['image_en'];
            }
            unset($res['image_en']);
            $sql = "SELECT lang_code ,title , description ,attachment_single FROM `offer_langs`";
            $sql .= " WHERE `offer_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);

            if ($res['offer_type'] == 'x_get_y') {

                $sql = "SELECT *   FROM `offer_x_y`";
                $sql .= " WHERE `offer_id` = '{$id}' ";
                // p($sql) ;
                $res['x_y_type'] = $this->mDb->getRow($sql);
                if ($res['x_y_type']) {
                    $res['x_y_type']['x_ids'] = substr($res['x_y_type']['x_ids'], 1);
                    $res['x_y_type']['x_ids'] = substr($res['x_y_type']['x_ids'], 0, -1);

                    $res['x_y_type']['y_ids'] = substr($res['x_y_type']['y_ids'], 1);
                    $res['x_y_type']['y_ids'] = substr($res['x_y_type']['y_ids'], 0, -1);
                    $res['offer_on'] = $res['x_y_type']['x_types'];
                }
            } else if ($res['offer_type'] == 'discount_percentage' || $res['offer_type'] == 'discount_constant') {
                $sql = "SELECT *   FROM `offer_discount`";
                $sql .= " WHERE `offer_id` = '{$id}' ";
                $res['offer_discount'] = $this->mDb->getRow($sql);
                if ($res['offer_discount']) {
                    $res['offer_discount']['ids'] = substr($res['offer_discount']['ids'], 1);
                    $res['offer_discount']['ids'] = substr($res['offer_discount']['ids'], 0, -1);
                    // p($res['offer_discount']['ids']);
                    $res['offer_on'] = $res['offer_discount']['apply_type_conditions'];
                }
            } else if ($res['offer_type'] == 'offer_normal') {
                $sql = "SELECT *   FROM `offer_normal`";
                $sql .= " WHERE `offer_id` = '{$id}' ";
                $res['offer_normal'] = $this->mDb->getRow($sql);
                if ($res['offer_normal']) {

                    if ($res['offer_normal']['offer_on'] == 'products') {
                        $res['offer_normal']['offer_on_id'] = $this->get_products_name_by_ids($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_normal']['offer_on'] == 'services') {
                        $res['offer_normal']['offer_on_id'] = $this->get_services_name_by_ids($res['offer_normal']['offer_on_id']);
                    } else if ($res['offer_normal']['offer_on'] == 'trademarks') {
                        $res['offer_normal']['offer_on_id'] = $this->get_trademarks_name_by_ids($res['offer_normal']['offer_on_id']);
                    }

                    // $res['offer_normal']['offer_on_id'] = substr($res['offer_normal']['offer_on_id'], 1);
                    // $res['offer_normal']['offer_on_id'] = substr($res['offer_normal']['offer_on_id'], 0, -1);
                }
            }
        }
        return $res;
    }

    public function get_services_name_by_ids($ids) {
        $sql = "SELECT ser_name , service_id as id  FROM  `service_langs`  ";
        $sql .= " WHERE  service_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_trademarks_name_by_ids($ids) {
        $ids = substr($ids, 1);
        $ids = substr($ids, 0, -1);
        $sql = "SELECT title , trademark_id as id  FROM  `trademark_langs`  ";
        $sql .= " WHERE  trademark_id  in  ({$ids})   and  lang_code = '{$this->lang_code}'    ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function get_products_name_by_ids($ids) {
        $sql = "SELECT  pl.name ,p.price , p.cost ,p.id  FROM  `products` p  ";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id  AND  pl.lang_code = 'ar'";

        $sql .= " WHERE  p.id  in  ({$ids}) ";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {
            $res[$i]['store_amounts'] = $this->productsObj->getProductStoreAmounts($res[$i]['id']);
            $res[$i]['images'] = $this->productsObj->getProductimgs($res[$i]['id']);
            $res[$i]['image'] = $res[$i]['images'][0]['name'];
        }
        //  echo $sql;
        return $res ? $res : array();
    }

    // offer_x_y
    //   function getProductsYForOffer_id($offer_id){
    //   $sql = "SELECT p.id  ,p.priority  FROM `offers` p";
    //   $sql .= " LEFT JOIN `offer_x_y` oxy ON p.id = oxy.offer_id ";
    //   $sql .= " WHERE   p.id = '{$offer_id}' ";
    //   $sql .= ' AND ( ( oxy.`y_ids`  like "%,' . $product_id . ',%" AND  oxy.x_types = "products" ) ';
    //   $sql .= '   || ( oxy.`x_ids`  like "%,' . $trademark_id . ',%" AND  oxy.x_types = "trademarks" ) ';
    //   $sql .= '  ||( ( (oxy.`x_ids`  like "%,-1,%" ) ';
    //   for ($i = 0; $i < count($product_services); $i++) {
    // 	  $sql .= ' ||  (oxy.`x_ids`  like "%,' . $product_services[$i]['service_id'] . ',%" ) ';
    //   }
    //   $sql .= ' ) AND oxy. x_types = "services" ) )   ';
    //   $sql .=   " ORDER BY p.priority desc limit 1 ";
    //   $offer_x_y = $this->mDb->getAll($sql);
    // }
}
